C
C***********************************************************************
C PROGRAM MSANDB (SAND-II MODIFIED BY M.MATZKE )
C VERSION 11-90
C THE PROGRAM CALCULATES AN ITERATED SOLUTION OF THE FEW CHANNEL
C UNFOLDING PROBLEM
C
C INPUT FILES:
C       5  : INPUT FILE NAMED CON (TERMINAL)
C            TO USE ANOTHER INPUT FILE ASSIGN ITS NAME TO CON
C FILE 20  : ACTIVITIES (REACTION RATES)
C FILE 15  : BINARY RESPONSE FUNCTIONS (CROSS SECTIONS)
C            IN SAND-II FORMAT E.G.OUTPUT FROM UMSBIB
C      14  : FLUENCE FILE IN THE SPECIAL FORMAT
C            (OPTIONAL, DEPENDING ON ANSWERS GIVEN TO TERMINAL QUESTIONS)
C
C OUTPUT FILES:
C FILE 14  : FLUENCE FILE IN THE SPECIAL FORMAT (FLUENCE PER DE)
C
C INPUT FROM TERMINAL (CONTENTS OF THE INPUT FILE):
C NAMES OF THE FILES
C DECISION NEW OR OLD FLUENCE FILE
C EPS   : ITERATION LIMIT OF SAND-II RUN, THE PROGRAM STOPS IF
C         CHI**2/KA IS LESS THAN EPS (KA: NUMBER OF REACTIONS)
C MSAN3 : MAXIMUM NUMBER OF ITERATIONS, IF EPS IS NOT REACHED
C IDR   : EACH IDR-TH ITERATION CH**2 IS PRINTED
C MODP  :=1   FLUENCE PER DLN(E) IS PLOTTED ON SCREEN
C        =2   LOG( FLUENCE PER DE) IS PLOTTED ON SCREEN
C
C THE PROGRAM USES A SUBROUTINE PLBILD TOGETHER WITH THE
C SCREEN SOFTWARE.
C
C
C USERS WITHOUT SCREEN SOFTWARE SHOULD INCLUDE A DUMMY ROUTINE
C PLBILD
C
C************************************************************************
C
      CHARACTER*4 HEAD(20),IREAC(30,2),KK3(19,2)
      COMMON/ACTS/ ACT1(30),SIG1(30),COVA(30,30),KA,ILC,IHC
      COMMON /SIGS/ KG,EL(641),CROSS(30,640)
      COMMON /ERG/ ACT2(30),COV2(30),F1(641),F2(641)
      COMMON /DAM/ CROSSD(16,641),IDOS
C
      CALL FILEIN(IFLUSS)
C
C
      CALL RACTS(HEAD,IREAC)
C NOW IN SIG1 THERE ARE ABSOLUTE VARIANCES
      CALL DOSNAM(KK3)
C
      CALL READS(IREAC,KK3)
      CALL FLUSS1(IFLUSS,IREAC)
      CALL ANFAN1(HEAD,IREAC)
C
C
      CALL DOSCAL(KK3)
C
      STOP
      END
C
C    ************************ *    A C T S    * ************************
C EINLESEN DER AKTIVITAETEN ACT1, DER UNSICHERHEITEN SIG1
      SUBROUTINE RACTS(HEADA,IREAC)
      CHARACTER*4 HEADA(20)
      CHARACTER*4 IREAC(30,2)
      COMMON/ACTS/ ACT1(30),SIG1(30),COVA(30,30),KA,ILC,IHC
C
C
C KA=NUMBER OF DETECTORS
C
C READ ACTIVITIES
      READ(20,1000,ERR=7777,END=7777) HEADA
 1000 FORMAT(20A4)
      WRITE(6,1010) HEADA
 1010 FORMAT(1H /1H ,'HEADLINE ACTIVITIES:'/1H /1H ,20A4)
      READ(20,*,END=7777,ERR=7777) KA
      DO 23 I=1,KA
   23 READ(20,1011,ERR=7777,END=7777) IREAC(I,1),IREAC(I,2),ACT1(I)
     *,SIG1(I)
C SIG1(I) IS GIVEN IN %
 1011 FORMAT(2A4,E10.3,F10.3)
 7777 CONTINUE
C MULTIPLICATION BY FACTA
      WRITE(*,2234)
 2234 FORMAT(' GIVE FACTOR FOR MULTIPLICATION WITH ACTIVITIES'/)
      READ(5,*) FACTA
      WRITE(6,3447) FACTA
 3447 FORMAT(' ALL ACTIVITIES ARE MULTIPLICATED BY:',E12.4/)
      DO 21 I=1,KA
      ACT1(I)=ACT1(I)*FACTA
C CONVERT TO ABSULUTE SIG-VALUES
      SIG1(I)=SIG1(I)*ACT1(I)/100.
   21 CONTINUE
C NOW ACTIVITIES ARE READ IN
C
C
      WRITE(6,6432)
 6432 FORMAT(' INPUT REACTIONS WITH STANDARD DEVIATIONS:'/)
      DO 6433 I=1,KA
      XHILF=SIG1(I)*100./ACT1(I)
 6433 WRITE(6,6434) I,IREAC(I,1),IREAC(I,2),ACT1(I),SIG1(I),XHILF
 6434 FORMAT(' ',I4,2X,2A4,1P,E12.4,2X,'+-',1P,E12.4,2X,' +-',0P,
     *F8.3,'%')
C
C
C
      DO 39 I=1,KA
   39 SIG1(I)=SIG1(I)*SIG1(I)
C
      RETURN
C
      END
C*****************************************************************
      SUBROUTINE READS(IREAC,KK3)
      CHARACTER*4 IFOIL1,IFOIL2
      CHARACTER*4 KK1(30,2),KK2(30,4),CN1,CN2,KK3(19,2)
     *,KK4(19,4),IREAC(30,2)
      LOGICAL OK
      COMMON /SIGS/ KG,EL(641),CROSS(30,640)
      COMMON/ACTS/ ACT1(30),SIG1(30),COVA(30,30),KA,ILC,IHC
      COMMON /ERG/ ACT2(30),COV2(30),F1(641),F2(641)
      COMMON /DAM/ CROSSD(16,641),IDOS
C*************************************************************
      READ(15) MPL1
      M=MPL1-1
      KG=M
      READ(15) (EL(I),I=1,MPL1)
      READ(15) NCOV
      NOVER=4+2*NCOV
      IF(NCOV.EQ.0) GOTO 4331
      DO 9 I=1,NCOV
      READ(15) NCOVE
    9 READ(15) (DUMMY,J=1,M)
 4331 CONTINUE
      READ(15) NFOIL
      OK=.TRUE.
      NF=0
      DO 100 I=1,KA
      IFOIL1=IREAC(I,1)
      IFOIL2=IREAC(I,2)
      CALL SEARCH(IFOIL1,IFOIL2,NFOIL,NF,NOVER,OK)
C
      BACKSPACE 15
      BACKSPACE 15
      IF(.NOT.OK) GOTO 3214
      READ(15) (KK1(I,K1),K1=1,2),(KK2(I,K1),K1=1,4)
      READ(15) CLAM,CN1,CN2,MAT,MT
      READ(15) (CROSS(I,K1),K1=1,M)
      GOTO 100
 3214 WRITE(6,3215)
 3215 FORMAT(' STOP, CORRECT INPUT ACTIVITY FILE!')
  100 CONTINUE
C
      KG=M
C READ DAMAGE CROSS SECTIONS
      DO 233 I=1,IDOS
      IFOIL1=KK3(I,1)
      IFOIL2=KK3(I,2)
      CALL SEARCH(IFOIL1,IFOIL2,NFOIL,NF,NOVER,OK)
C
      BACKSPACE 15
      BACKSPACE 15
      IF(.NOT.OK) GOTO 233
      READ(15) (KK3(I,K1),K1=1,2),(KK4(I,K1),K1=1,4)
      READ(15) CLAM,CN1,CN2,MAT,MT
      READ(15) (CROSSD(I,K1),K1=1,M)
  233 CONTINUE
      CLOSE(15)
      RETURN
      END
C*****************************************************************
      SUBROUTINE FLUSS1(IFLUSS,IREAC)
      CHARACTER*4 HEAD(20),IREAC(30,2)
      COMMON /ERG/ACT2(30),COV2(30),F1(641),F2(641)
      COMMON/ACTS/ ACT1(30),SIG1(30),COVA(30,30),KA,ILC,IHC
      COMMON /SIGS/ KG,EL(641),CROSS(30,640)
C
      IF(IFLUSS.NE.0) GOTO 10
      WRITE(6,4332)
 4332 FORMAT(' ','NEW FILE')
C F1(I) ARE GROUP VALUES
      WRITE(*,7253)
 7253 FORMAT(' GIVE ENERGY E  OF MONO-ENERGY PART IN MEV AND ',
     *'WEIGHT OF THIS CONTRIBUTION. WEIGHT BETWEEN 0.0 AND 1.0'/
     *' IF NO MONOENERGETIC CONTRIBUTION IS WANTED, TYPE: 0.0,0.0'/)
      READ(5,*) EMON,WEI
C
      WRITE(6,3285) EMON,WEI
 3285 FORMAT(' '/' MONOENERGY CONTRIBUTION:'/
     *' E=',1P,E12.4,' MEV, WEIGHT: ',0P,F10.3)
      II1=0
      MS=0
      DO 20 I=1,KG
      F1(I)=(EL(I+1)-EL(I))/SQRT(EL(I+1)*EL(I))
      IF(EL(I).GT.0.2.AND.MS.EQ.0) MS=I
      IF(MS.NE.0) F1(I)=F1(MS)*SQRT(EL(I)/EL(MS))*EXP(
     *-(EL(I)-EL(MS))/1.29)*(EL(I+1)-EL(I))/(EL(MS+1)-EL(MS))
      IF(EMON.EQ.0) GOTO 20
      IF(EL(I).LE.EMON.AND.EL(I+1).GT.EMON) II1=I
   20 CONTINUE
      IF(EMON.EQ.0.0) GOTO 481
      SUM=0.0
      DO 22 I=1,KG
   22 SUM=SUM+F1(I)
      SUM=SUM-F1(II1)
      DO 23 I=1,KG
   23 F1(I)=F1(I)*(1.0-WEI)/SUM
      IF(WEI.NE.0) F1(II1)=WEI
      GOTO 481
   10 CONTINUE
      READ(14,7238,END=7239,ERR=7239) HEAD
 7238 FORMAT(20A4)
 7239 WRITE(6,7240) HEAD
 7240 FORMAT(' '/' HEADLINE INPUT FLUENCE FILE 14: '/' ',20A4/)
      READ(14,*) MODE,MEV
      IF(MODE.EQ.0) GOTO 7854
      READ(14,*) ILL,IHH,KG,XDUM
      MPL1=KG+1
      EL(MPL1)=XDUM
      GOTO 7855
 7854 WRITE(6,7856)
 7856 FORMAT(' NO GROUP FLUENCE VALUES IN FILE 14. STOP')
      STOP
 7855 CONTINUE
C F1(I) VALUES READ IN ARE GROUP VALUES
      DO 7836 I=1,KG
      READ(14,*) EL(I),F1(I)
 7836 CONTINUE
      IF(MODE.EQ.1) GOTO 7859
      DO 7860 I=1,KG
 7860 F1(I)=F1(I)/(EL(I+1)-EL(I))
C NOW F1 HAS GROUP FLUENCE PER UNIT ENERGY
 7859 CONTINUE
      IF(MEV.EQ.1) GOTO 7861
      DO 7862 I=1,MPL1
 7862 EL(I)=EL(I)*1.0E-6
 7861 CONTINUE
C
      DO 30 I=1,KG
C
   30 F1(I)=F1(I)*(EL(I+1)-EL(I))
      REWIND 14
  481 CONTINUE
C
C
      WRITE(6,3383)
 3383 FORMAT(' '/' NO COVARIANCE MATRIX OF ACTIVITIES USED'/)
      DO 71 I=1,KA
      ACT2(I)=0.0
      DO 72 K1=1,KG
  72  ACT2(I)=ACT2(I)+F1(K1)*CROSS(I,K1)
  71  CONTINUE
      WRITE(6,2008)
 2008 FORMAT(' '//' ACTIVITIES   CALCULATED      MEASURED     SIGMA'/)
      DO 81 I=1,KA
      XHILF=SQRT(SIG1(I))
  81  WRITE(6,2009) (IREAC(I,K),K=1,2),ACT2(I),ACT1(I),XHILF
 2009 FORMAT(' ',2A4,2X,1P,2(E12.4,2X),' +-',E12.4)
      RETURN
      END
C    ********************** *    A N F A N 1    * **********************
      SUBROUTINE ANFAN1(HEAD,IREAC)
      DIMENSION SUMZ(641),SUMN(641),XPLOT(641),YPLOT(641),DELTAE(640)
     *,XLNDE(640)
C
      REAL*8 CHI,CHI1,CHI2,SUMZ,SUMN,DXH1,DXH2,DXH
      CHARACTER*4 HEAD(20),IREAC(30,2)
      CHARACTER*20 TEXT,COM
      COMMON/ACTS/ ACT1(30),SIG1(30),COVA(30,30),KA,ILC,IHC
      COMMON /SIGS/ KG,EL(641),CROSS(30,640)
      COMMON /ERG/ ACT2(30),COV2(30),F1(641),F2(641)
C
C
      DO 2278 I=1,KG
      DELTAE(I)=EL(I+1)-EL(I)
 2278 XLNDE(I)=ALOG(EL(I+1)/EL(I))
      KG1=KG
      WRITE(*,7722)
 7722 FORMAT(1H ,'EPS: RELATIVE ITERATION LIMIT '/
     *1H ,'FOR ABS(CHI(K+1)/CHI(K) -1) < EPS THE PROGRAM STOPS'/
     11H ,'MSAN3: MAXIMUM NUMBER OF ITERATIONS'/
     11H ,'IDR: EACH IDR-TH ITERATION IS PRINTED'/
     11H ,'MODP: 1 (LOG-LIN GROUP-FLUENCE PER DLN E)'/
     11H ,'      2 (LOG-LOG GROUP-FLUENCE PER DE IS PLOTTED)'/
     21H ,'GIVE  EPS, MSAN3, IDR, MODP '/)
      READ(5,*) EPS,MSAN3,IDR,MODP
C EPS: WENN CHI(K+1)/CHI(K)-1 < EPS: ABBRUCH
      WRITE(6,7723) EPS,IDR,MSAN3,MODP
 7723 FORMAT(' '/
     1' EPS  =',1P,E12.4/
     2' IDR  =',I5/
     3' MSAN3=',I5/
     4' MODP =',I5)
      MSAND=0
      MDRU=0
      DO 11 I=1,KA
      COV2(I)=0.0
      IF(ACT1(I).NE.0.0) COV2(I)=SIG1(I)/(ACT1(I)*ACT1(I))
   11 CONTINUE
      DO 14 I=1,KA
      XHILF2=0.0
      IF(COV2(I).NE.0.0) XHILF2=1.0/COV2(I)
      COV2(I)=XHILF2
   14 CONTINUE
      DO 30 I=1,KA
      ACT2(I)=0.0
      DO 30 J=1,KG
   30 ACT2(I)=ACT2(I)+CROSS(I,J)*F1(J)
      SUMAC1=0.0
      SUMAC2=0.0
      DO 31 I=1,KA
      IF((ACT1(I).EQ.0.0).OR.(ACT2(I).EQ.0.0)) GOTO 31
      SUMAC1=SUMAC1+ALOG(ACT1(I)/ACT2(I))*COV2(I)
      SUMAC2=SUMAC2+COV2(I)
   31 CONTINUE
      SUMAC=SUMAC1/SUMAC2
      SUMAC=EXP(SUMAC)
      DO 32 I=1,KA
   32 ACT2(I)=ACT2(I)*SUMAC
      DO 33 I=1,KG
   33 F1(I)=F1(I)*SUMAC
      CALL CHICAL(ACT1,ACT2,COV2,KA,CHI)
      CHI2=CHI
      MSAND=0
      MDRU=0
      MPLOT=0
      MPL1=KG+1
   41 CHI1=CHI2
      MDRU=MDRU+1
      MSAND=MSAND+1
      DO 55 I=1,KG
      SUMZ(I)=0.0D0
   55 SUMN(I)=0.0D0
      DO 56 L1=1,KA
      IF((ACT1(L1).EQ.0.0).OR.(ACT2(L1).EQ.0.0)) GOTO 56
      DXH2=DLOG(DBLE(ACT1(L1))/DBLE(ACT2(L1)))
C
      DO 57 J=1,KG
      DXH1=DBLE(CROSS(L1,J)*F1(J)/ACT2(L1))
C
      DXH=DXH1*DBLE(COV2(L1))
C
      SUMZ(J)=SUMZ(J)+DXH*DXH2
C
   57 SUMN(J)=SUMN(J)+DXH
C
   56 CONTINUE
      DO 554 J=1,KG
      F1(J)=F1(J)*DEXP(SUMZ(J)/SUMN(J))
      IF(F1(J).LT.1.0E-20) F1(J)=1.0E-20
  554 CONTINUE
      SUM=0.0
      DO 70 L=1,KG
   70 SUM=SUM+F1(L)
      IF(MDRU.LT.IDR) GOTO 5734
      WRITE(6,1111) MSAND,SUM,CHI
 1111 FORMAT(/1H ,'MSAND=',I4,' NORM=',1P,E12.4,' CHI=',1P,D12.4)
 5734 CONTINUE
      DO 80 I=1,KA
      SUM=0.0
      DO 90 L=1,KG
   90 SUM=SUM+CROSS(I,L)*F1(L)
  80  ACT2(I)=SUM
      MPL1=KG+1
      DO 4953 I=1,KG
      XPLOT(I)=EL(I)
      YPLOT(I)=F1(I)/DELTAE(I)
 4953 CONTINUE
      XPLOT(MPL1)=EL(MPL1)

 4444 FORMAT(1H ,5(I4,1P,2E10.3))
      CALL CHICAL(ACT1,ACT2,COV2,KA,CHI)
      CHI2=CHI
C***********************************************
      MLAUF4=MSAND
      IF(MODP.EQ.1) THEN
        LAY=-2
      ELSE
        LAY=4
      END IF
      TEXT(1:20)='                    '
      COM(1:10)='RUN NO.   '
      WRITE(COM(11:14),'(I4)') MSAND
      IF(MSAND.EQ.4)  THEN
      CALL PLBILD(XPLOT,YPLOT,YPLOT,MPL1,LAY,1,1,1.0,1,TEXT,COM,1)
      IZEIG=2
      CALL PLBILD(XPLOT,YPLOT,YPLOT,MPL1,LAY,1,1,1.0,IZEIG,TEXT,COM,1)
      LAY2=LAY
      END IF
      IF (MSAND.GE.4) THEN
C
      CALL PLBILD(XPLOT,YPLOT,YPLOT,MPL1,LAY2,1,1,1.0,IZEIG,TEXT,COM,1)
      IF(MDRU.EQ.IDR) THEN
      LAY2=LAY
      ELSE
      LAY2=0
      END IF
      END IF
C
      IF(MDRU.EQ.IDR) MDRU=0
      IF(SNGL(CHI2).LT.(0.01*KA)) GOTO 3040
      IF(ABS(SNGL(CHI2/CHI1)-1.0).GT.EPS.AND.MSAND.LT.MSAN3) GOTO 41
 3040 SUM=0.0
C
      LAY2=LAY
      IZEIG=1
      CALL PLBILD(XPLOT,YPLOT,YPLOT,MPL1,LAY2,1,1,1.0,IZEIG,TEXT,COM,1)
C
      WRITE(6,3042)
 3042 FORMAT(1H /1H ,'RESULTS'/1H )
      WRITE(6,3072) MSAND,CHI2
 3072 FORMAT(1H /1H ,'ITERATIONS:',I6,'   CHI=',1P,D12.4/1H )
      WRITE(6,2222)
 2222 FORMAT(/' ','        E(I)        F(I) (GROUP-VALUES)'//)
      DO 801 I=1,KG,5
      I1=I+1
      I2=I+2
      I3=I+3
      I4=I+4
      WRITE(6,4444) I,EL(I),F1(I),I1,EL(I1),F1(I1)
     *,I2,EL(I2),F1(I2),I3,EL(I3),F1(I3),I4,EL(I4),F1(I4)
      SUM=SUM+F1(I)+F1(I1)+F1(I2)+F1(I3)+F1(I4)
  801 CONTINUE
      DO 71 I=1,KA
      ACT2(I)=0.0
      DO 72 K1=1,KG
  72  ACT2(I)=ACT2(I)+F1(K1)*CROSS(I,K1)
  71  CONTINUE
      WRITE(6,2008)
 2008 FORMAT(' '//' ACTIVITIES  CALCULATED     MEASURED ',
     1'    UNCERTAINTY'/)
      DO 81 I=1,KA
      XHILF=SQRT(SIG1(I))
      XHILF1=100.*XHILF/ACT1(I)
  81  WRITE(6,2009) (IREAC(I,K),K=1,2),ACT2(I),ACT1(I),XHILF,XHILF1
 2009 FORMAT(' ',2A4,2X,1P,2(E12.4,2X),' +-',1P,E12.4,'  ',0P,
     *F10.3,'%')
C
      WRITE(6,899) SUM
  899 FORMAT(//1H ,'NORM=',1P,E12.4//)
C
C
      WRITE(14,7854) HEAD
 7854 FORMAT(20A4)
      MODE=1
      MEV=1
      WRITE(14,1455) MODE,MEV
 1455 FORMAT(' ',2(I4,2H ,),5H 1.0,)
      ILLL=1
      IHHH=KG
      MPL1=KG+1
      WRITE(14,*) ILLL,IHHH,KG,EL(MPL1)
      DO 733 I=1,KG
      XHILF3=F1(I)
      XHILF3=XHILF3/(EL(I+1)-EL(I))
C USE 100% UNCERTAINTY
      XHILF4=XHILF3
      WRITE(14,5347) EL(I),XHILF3,XHILF4
  733 CONTINUE
 5347 FORMAT(1H ,3(E12.5,',  '))
C
      RETURN
      END
C
C**************************************************************
      SUBROUTINE CHICAL(ACT1,SIGR,CC,KA,CHI)
      REAL*8 CHI,XH,XH1
      DIMENSION ACT1(KA),SIGR(KA),CC(KA)
      CHI=0.0D0
C
      DO 10 I=1,KA
      IF((ACT1(I).EQ.0.0).OR.(SIGR(I).EQ.0.0)) GOTO 10
      XH=DLOG(DBLE(ACT1(I)/SIGR(I)))
      XH1=XH*XH*DBLE(CC(I))
      CHI=CHI+XH1
   10 CONTINUE
      RETURN
      END
C*********************************************************
      SUBROUTINE SEARCH(IFOIL1,IFOIL2,NFOIL,NF,NOVER,OK)
      LOGICAL OK,AGAIN
      CHARACTER*4 IFOIL1,IFOIL2,INF1,INF2,F2(4)
      AGAIN=.TRUE.
      IF(NF.EQ.NFOIL)GO TO 5
    1 READ(15)INF1,INF2,F2
      NF=NF+1
      IF (INF1.EQ.IFOIL1.AND.INF2.EQ.IFOIL2) GOTO 2
      READ(15)
      READ(15)
      IF (NF.LT.NFOIL) GOTO 1
      IF (.NOT.AGAIN) GOTO 4
    5 AGAIN=.FALSE.
      NF=0
      REWIND 15
      DO 3 I=1,NOVER
    3 READ(15)
      GOTO 1
    2 READ(15)
      OK=.TRUE.
      RETURN
  4   OK=.FALSE.
      WRITE(6,1000) IFOIL1,IFOIL2
 1000 FORMAT(1H ,'REACTION ',2A4,'   NOT ON CROSS SECTION FILE')
      RETURN
      END
C***********************************************
C******************************************************+
      SUBROUTINE DOSNAM(KK3)
C READ DOS-NAMES
      CHARACTER*4 IBL,KK3(19,2)
      COMMON /DAM/ CROSSD(16,641),IDOS
      DATA IBL/'    '/
C
C READ NUMBER OF DOSE REACTIONS
      READ(20,*) IDOS
      DO 10 I=1,IDOS
      KK3(I,1)=IBL
      KK3(I,2)=IBL
      READ(20,1000,END=999,ERR=999) KK3(I,1),KK3(I,2)
 1000 FORMAT(2A4)
  999 CONTINUE
   10 CONTINUE
      CLOSE(20)
      RETURN
      END
C******************************************************************
      SUBROUTINE DOSCAL(KK3)
C
      CHARACTER*4 KK3(19,2)
      COMMON/ACTS/ ACT1(30),SIG1(30),COVA(30,30),KA,ILC,IHC
      COMMON /SIGS/ KG,EL(641),CROSS(30,640)
      COMMON /ERG/ ACT2(30),COV2(30),F1(641),F2(641)
      COMMON /DAM/ CROSSD(16,641),IDOS
      WRITE(6,1000)
 1000 FORMAT(' ','DOSE RESULTS'//)
      DO 10 I=1,IDOS
      ACT2(I)=0.0
      DO 11 J=1,KG
   11 ACT2(I)=ACT2(I)+F1(J)*CROSSD(I,J)
      WRITE(6,2000) KK3(I,1),KK3(I,2),ACT2(I)
 2000 FORMAT(' ',2A4,2X,1P,E12.4)
   10 CONTINUE
      RETURN
      END
C
C*****************************************
      SUBROUTINE FILEIN(IFLUSS)
      CHARACTER*20 LISTE,LISTE1
      DATA LISTE /'              '/
C
 501  FORMAT(A20)
      OPEN(5,FILE='CON')
      LISTE1=LISTE
C
      WRITE(*,503)
  503 FORMAT(
     1' GIVE NAME OF PRINTER FILE OR PRINTER IDENTIFICATION (LPT1):'/)
      READ(5,501,ERR=504,END=504) LISTE1
  504 OPEN(6,FILE=LISTE1)
      LISTE1=LISTE
C***************************************************************
C
      WRITE(6,6255)
 6255 FORMAT(' '//
     *' PROGRAM MSANDB BY M. MATZKE, UPDATED NOV  90'//
     *' SAND-II     ESTIMATION OF FLUENCE RATE '/
     *'                      '/)
C
C
      LISTE1=LISTE
      WRITE(*,1224)
 1224 FORMAT(' GIVE NAME OF ACTIVITY FILE'/)
      READ(5,1225,ERR=1226,END=1226) LISTE1
      WRITE(6,3221) LISTE1
 3221 FORMAT(' INPUT ACTIVITY FILE:',A20)
 1225 FORMAT(A20)
 1226 OPEN(20,FILE=LISTE1,STATUS='OLD',FORM='FORMATTED')
C************************************************************
      LISTE1=LISTE
      WRITE(*,1227)
 1227 FORMAT(' NAME OF FILE 15, BINARY CROSS SECTION FILE'/
     1'  (E.G. IRDF.BIN) ?'/)
      READ(5,2000,END=117,ERR=117) LISTE1
 2000 FORMAT(A20)
  117 CONTINUE
      OPEN(15,FILE=LISTE1,STATUS='OLD',FORM='UNFORMATTED')
      WRITE(6,8107) LISTE1
 8107 FORMAT(' '//' *************************'/
     *' BINARY CROSS SECTION INPUT FILE:  ',A20)
C*************************************************************
      LISTE1=LISTE
      WRITE(*,5555)
 5555 FORMAT(' IFLUSS=0 : NEW SPECTRUM, IFLUSS=1: OLD SPECTRUM'/
     *1H ,'IFLUSS ?'/)
      READ(5,*) IFLUSS
      WRITE(*,6666)
 6666 FORMAT(' NAME OF SPECTRUM FILE?'/)
      READ(5,7777,END=8888,ERR=8888) LISTE
 7777 FORMAT(A12)
 8888 CONTINUE
C
      IF(IFLUSS.EQ.0)
     *OPEN(14,FILE=LISTE,STATUS='NEW',FORM='FORMATTED')
C
      IF(IFLUSS.EQ.1)
     *OPEN(14,FILE=LISTE,STATUS='OLD',FORM='FORMATTED')
      WRITE(6,4331) LISTE
 4331 FORMAT(' '/' FLUX-FILE: ',A12)
      IF(IFLUSS.EQ.0) WRITE(6,6443)
 6443 FORMAT(' NEW FILE, OUTPUT GROUP VALUES PER DE')
      IF(IFLUSS.EQ.1) WRITE(6,6444)
 6444 FORMAT(' OLD FILE, OUTPUT GROUP VALUES PER DE, OLD DATA LOST!')
      RETURN
      END
C***************************************************************************
C****************** FOLLOWING THE ROUTINE PLBILD ******
C****************** FOR SCREEN GRAFICS, WHICH MAY BE REPLACED
C****************** BY A DUMMY ROUTINE
      SUBROUTINE
     *PLBILD(X,Y,SIG,NP,LAY,MODIN,MODPL,FAKT,IZEIG,TEXT,COM,MEV)
C
      CHARACTER*20 TEXT,COM
      LOGICAL OD
      DIMENSION X(NP),Y(NP),SIG(NP)
C IZEIG=0 KEIN BILD
C IZEIG=1 BILD WIRD GEZEIGT, EINGABE ERWARTET
C IZEIG=2 BILD WIRD GEZEIGT UND BLEIBT STEHEN
C
C LAY=0 KEIN NEUER RAHMEN
C LAY=1 LIN-LIN
C    =2 LOG-LIN
C    =3 LIN-LOG
C    =4 LOG-LOG
C LAY NEGATIV: F(E)*E GEPLOTTET
C
C MODIN=1 HISTOGRAMMWERTE ALS EINGABE
C      =2 PUNKTWERTE ALS EINGABE
C
C MODPL=1 HISTOGRAMM
C      =2 LINIE
C      =3 PUNKTE
C MODIN NEGATIV: UNSICHERHEITEN GEPLOTTET
      INQUIRE(UNIT=29,OPENED=OD)
      IF(.NOT.OD) THEN
      OPEN(29,FILE='PLOTOB',FORM='UNFORMATTED',STATUS='OLD',ERR=30)
   30 OPEN(29,FILE='PLOTOB',FORM='UNFORMATTED',STATUS='NEW')
      END IF
      WRITE(29) NP,LAY,MODIN,MODPL,FAKT,IZEIG,TEXT,COM,MEV
C
      WRITE(29) X,Y,SIG
      RETURN
      END
