C
C     PROGRAM MSPECT
C**********************************************************************
C     PROGRAM MSPECT TO CREATE FLUENCE FILES     VERSION 11.90        *
C                                                                     *
C                                                                     *
C     THE PROGRAM IS THOUGHT TO BE CHANGED BY THE USER                *
C     FOR SPECIAL PROBLEMS                                            *
C                                                                     *
C     INPUT : FILE 5 NAMED 'CON', WHICH MEANS TERMINAL INPUT AT PC    *
C     FOR OTHER COMPUTERS YOU HAVE TO ASSIGN THE PHYSICAL TERMINAL    *
C     NAME TO CON.                                                    *
C                                                                     *
C     OUTPUT: FILE 6, PRINTER (LPT1), NAME IS ASKED DURING RUN        *
C                                                                     *
C     OUTPUT: FILE 15:                                                *
C     SPECTRAL FLUENCE VALUES AT 640 ENERGY POINTS                    *
C     ENERGIES CALCULATED FROM 640 GROUP SAND STRUCTURE BY            *
C     E(I)=SQRT(EL(I)*EL(I+1))   EL(I): SAND-II ENERGIES,             *
C     FOR SAND-STRUCTURE: PROGRAM ETAB FROM SAND-II IS USED.          *
C     THE NAME OF THE OUTPUT FILE IS ASKED BY THE PROGRAM FROM        *
C     INPUT FILE 5                                                    *
C     OUTPUT EITHER POINT VALUES OR FLEUNCE VALUES (SWITCH MODE)      *
C     THE OUTPUT FILE CONTAINS:                                       *
C                                                                     *
C     LINE 1: COMMENT CARD (20A4)                                     *
C     LINE 2: MODE,MEV                                                *
C     MODE=0  SPECTRAL POINT VALUES                                   *
C         =1  SPECTRAL GROUP FLUENCE VALUES (PER DE)                  *
C             GROUP FLUENCE PER ENERGY                                *
C         =2  GROUP FLUENCE VALUES                                    *
C         =3  GROUP FLUENCE PER LETHARGY                              *
C     MEV=0   ENERGIES ARE GIVEN IN EV                                *
C     MEV=1   ENERGIES ARE GIVEN IN MEV (DEFAULT)                     *
C     MEV=2   ENERGIES ARE GIVEN IN KEV                               *
C     FORMAT(' ',2(I4,1H,))                                           *
C                                                                     *
C     LINE 3:                                                         *
C     I1,I2,I,EL(641),IUN                  FORMAT(' ',3(I4,E12.5)     *
C     I1: FIRST INDEX (1)                                             *
C     I2: LAST  INDEX (640)                                           *
C     I:  NUMBER OF VALUES (640)                                      *
C     IUN:   IUN=0  (NO UNCERTAINTIES PRINTED INTO THE FLUENCE FILE)  *
C               =1  UNCERTAINTIES PRINTED (NOT FOR THIS PROGRAM)      *
C     LINE 4 TO LAST LINE E(I),FLUX(I)     FORMAT(' ',1P2(E12.4)      *
C                                                                     *
C     AN OUTPUT FLUX OPTION IS REQUIRED:                              *
C     MFLUX=0  :                                                      *
C     SPECTRUM:                                                       *
C     E > 0.5 MEV: FISSION SPECTRUM WITH ET=1.29 MEV                  *
C     0.2E-6 MEV < E <= 0.5 MEV: 1/E SPECTRUM                         *
C     E<=0.2E-6 MEV THERMAL SPECTRUM                                  *
C     1.0E-5 OF THE FIRST 1/E VALUE                                   *
C     TO BE CHANGED BY USER:                                          *
C     (IN THE PRESENT VERSION REPLACED BY COMMENT CARDS)              *
C     AT 24.0E-3 MEV IS A MONOENERGETIC LINE (FLUENCE VALUE  TIMES    *
C     100)                                                            *
C     MFLUX=1:                                                        *
C     WATT SPECTRUM                                                   *
C     MFLUX=2                                                         *
C     NBS URANIUM FISSION                                             *
C     MFLUX=3:                                                        *
C     NBS CALIFORNIUM FISSION                                         *
C     THE SPECTRUM IS NORMALIZED TO 1000                              *
C     FOR MORE DETAIL LOOK AT THE SIMPLE PROGRAM                      *
C**********************************************************************
C
C
      DIMENSION EL(641),EX(641),FLUSS1(641),XPLOT(641),YPLOT(641)
      CHARACTER*4 HEAD(20)
      CHARACTER*40 HEAD1(2)
      CHARACTER*20 TEXT,COM
      EQUIVALENCE (HEAD(1),HEAD1(1)),(TEXT,HEAD1(1))
      DATA HEAD1
     */'TEST-RUN WITH USER INPUT SPECTRUM       ',
     * '                                        '/
C
C     OPEN INPUT AND OUTPUT FILES
      CALL FILEIN
C
C WHICH MODE ?
      WRITE(*,7)
    7 FORMAT(' MODE OF THE OUTPUT FILE:'/
     *' MODE=0  SPECTRAL POINT VALUES'/
     *'     =1  SPECTRAL GROUP FLUENCE VALUES (PER DE)'/
     *'         GROUP FLUENCE PER ENERGY'/
     *'     =2  GROUP FLUENCE VALUES'/
     *'     =3  GROUP FLUENCE PER LETHARGY'/
     *' ENERGY SCALING IN OUTPUT FILE:'/
     *'  MEV=1   ENERGIES IN MEV'/
     *'     =0   ENERGIES IN EV'/
     *'     =2   ENERGIES IN KEV'/
     *' '/' GIVE MODE, MEV'/)
      READ(5,*) MODE,MEV
C
C FILL EL(641) WITH SAND ENERGIES
      MPL1=641
      KG1=640
      CALL ETAB(EL,MPL1)
C POINT VALUES IN ENERGY (LOG AVERAGES):
      DO 38 I=1,KG1
   38 EX(I)=SQRT(EL(I)*EL(I+1))
C READ FLUX OPTION
      WRITE(*,2286)
 2286 FORMAT(' THE FOLLOWING SPECTRA ARE POSSIBLE:'/
     *' MFLUX=0  : SPECTRUM GIVEN BY USER (SEE BELOW)'/
     *'      =1  : WATT SPECTRUM  FOR U-235 GIVEN BY'/
     *'            F(E)=0.48395*SQRT(E)*EXP(-E)*SINH(SQRT(2E))'/
     *'      =2  : NBS URANIUM FISSION'/
     *'      =3  : NBS CALIFORNIUM FISSION'/
     *'  GIVE MFLUX !'/)
      READ(5,*) MFLUX
      IF(MFLUX.EQ.1)
     *HEAD1(1)(1:40)='WATT SPECTRUM FOR URANIUM FISSION       '
      IF(MFLUX.EQ.2)
     *HEAD1(1)(1:40)='NBS URANIUM FISSION SPECTRUM            '
      IF(MFLUX.EQ.3)
     *HEAD1(1)(1:40)='NBS CALIFORNIUM FISSION SPECTRUM        '
C
      IF(MFLUX.NE.0) GOTO 2287
C MFLUX=0 *********************** INSERT USER OPTIONS:
C              FLUSS1(I)=FUNCTION(EX(I))
      MTH=0
      MS=0
      MONO=0
      DO 381 I=1,KG1
      IF(EX(I).GT.0.2E-6.AND.MTH.EQ.0) MTH=I
      IF(EX(I).GT.0.5.AND.MS.EQ.0) MS=I
      IF(EX(I).GT.24.0E-3.AND.MONO.EQ.0) MONO=I
  381 CONTINUE
C FILL THERMAL PART:
      DO 39 I=1,MTH
      xhilf=ex(I)/0.0253e-6
  39  FLUSS1(I)=xhilf*exp(-xhilf)
C
      MW=MTH
C FILL 1/E:
      DO 40 I=MW,MS
  40  FLUSS1(I)=FLUSS1(MTH)*EX(MTH)/EX(I)
      MW=MS
C FILL FAST:
      DO 41 I=MW,KG1
  41  FLUSS1(I)=FLUSS1(MS)*SQRT(EX(I)/EX(MS))*EXP(-(EX(I)-EX(MS))/1.29)
C MONO CONTRIBUTION may be added:
c     FLUSS1(MONO)=100.0*FLUSS1(MONO)
c     FLUSS1(MONO-1)=50.0*FLUSS1(MONO-1)
c     FLUSS1(MONO+1)=50.0*FLUSS1(MONO+1)
      GOTO 2288
C END MFLUX=0 (USER OPTIONS) ********************************************
 2287 CONTINUE
C FISSION SPECTRA:
      IF(MFLUX.EQ.1) THEN
      DO 2290 I=1,KG1
      XHILF=EXP(SQRT(2.0*EX(I)))
      FLUSS1(I)=0.48395*EXP(-EX(I))*(XHILF-1.0/XHILF)*0.5
 2290 CONTINUE
      ELSE
      DO 2295 I=1,KG1
      X=EX(I)
      IF(MFLUX.EQ.2) THEN
        Z=0.7501*SQRT(X)*EXP(-1.5*X/1.97)
        ELSE
        Z=0.6672*SQRT(X)*EXP(-1.5*X/2.13)
      END IF
C
      IF(MFLUX.EQ.1) THEN
       IF(X.LT.0.25) THEN
        DIF5=Z*(0.847+0.8*X)
       ELSE
        IF(X.LT.0.8) THEN
         DIF5=Z*(1.082-0.14*X)
        ELSE
         IF(X.LT.1.5) THEN
          DIF5=Z*(0.9380+0.040*X)
         ELSE
          IF(X.LT.6.0) THEN
           DIF5=Z*(0.983+0.01*X)
          ELSE
           DIF5=1.043*Z*EXP(-0.06*(X-6.0)/1.043)
          END IF
         END IF
        END IF
       END IF
      ELSE
       IF(X.LT.0.25) THEN
        DIF5=Z*(0.763+1.2*X)
       ELSE
        IF(X.LT.0.8) THEN
         DIF5=Z*(1.098-0.14*X)
        ELSE
         IF(X.LT.1.5) THEN
          DIF5=Z*(0.9668+0.024*X)
         ELSE
          IF(X.LT.6.0) THEN
           DIF5=Z*(1.0037-0.0006*X)
          ELSE
           DIF5=Z*EXP(-0.03*(X-6.0))
          END IF
         END IF
        END IF
       END IF
      END IF
      FLUSS1(I)=DIF5
 2295 CONTINUE
         END IF
C
 2288 CONTINUE
C NORMALIZE TO 1000
      SUM=0.0
      DO 7926 I=1,KG1
 7926 SUM=SUM+FLUSS1(I)*(EL(I+1)-EL(I))
C
      DO 3923 I=1,KG1
      FLUSS1(I)=FLUSS1(I)*1000./SUM
      XPLOT(I)=EL(I)
      YPLOT(I)=FLUSS1(I)
 3923 CONTINUE
      xplot(mpl1)=el(mpl1)
C
C OUTPUT
      IUN=0
C
      CALL PLBILD(XPLOT,YPLOT,YPLOT,MPL1,-2,1,1,1.0,1,TEXT,COM,1)
      CALL PLBILD(XPLOT,YPLOT,YPLOT,MPL1,4,1,1,1.0,1,TEXT,COM,1)
      CALL OUTFLU(15,EL,FLUSS1,FLUSS1,MPL1,KG1,HEAD,MODE,MEV,IUN)
      STOP
      END
C
C
      SUBROUTINE ETAB(EL,MPL1)
      DIMENSION ENUL(45),EL(MPL1)
      DATA ENUL/1.,1.05,1.1,1.15,1.2,1.275,1.35,1.425,1.5,1.6,1.7,
     11.8,1.9,2.,2.1,2.2,2.3,2.4,2.55,2.7,2.8,3.,3.2,3.4,3.6,3.8,4.,
     24.25,4.5,4.75,5.,5.25,5.5,5.75,6.,6.3,6.6,6.9,7.2,7.6,8.,8.4,
     38.8,9.2,9.6/
      J=0
      DO 12  I=1,10
      IN=I-5
      P=10.**IN
      DO 12  IK=1,45
      J=J+1
   12 EL(J) = ENUL(IK)*P
      EL(451) = 1.E+6
      DO 24  I=452,641
   24 EL(I) = EL(I-1)+1.E+5
      NEL = 641
      DO 33 I=1,NEL
   33 EL(I)=EL(I)*1.0E-6
      RETURN
      END
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE FILEIN
C
      CHARACTER*20 LISTE,LISTE1
C
      DATA LISTE /'                                           '/
C
      LISTE1=LISTE
C
  501 FORMAT(A20)
      OPEN(5,FILE='CON')
C
      WRITE(*,503)
  503 FORMAT(
     1' GIVE NAME OF PRINTER FILE OR PRINTER IDENTIFICATION (LPT1):'/)
      READ(5,501,ERR=504,END=504) LISTE1
  504 OPEN(6,FILE=LISTE1)
C
      WRITE(6,3000)
 3000 FORMAT(' '/
     *' ************************************************************'/
     1' *********     PROGRAM MSPECT BY MATZKE (VERSION 11.90)  ****'/
     1' '/
     1' *************************************************************'/
     1' PROGRAM MSPECT TO CREATE FLUENCE FILES     VERSION 11.90   '///
     1' THE PROGRAM IS THOUGHT TO BE CHANGED BY THE USER             '/
     1' FOR SPECIAL PROBLEMS                                        '//
     1' INPUT : FILE 5 NAMED CON                                   '//
     1' OUTPUT: FILE 6, PRINTER (LPT1), NAME IS ASKED DURING RUN     ')
      WRITE(6,3001)
 3001 FORMAT(' '/
     1' OUTPUT: FILE 15                                              '/
     1' OUTPUT: SPECTRAL FLUENCE VALUES AT 640 ENERGY POINTS         '/
     1' ENERGIES CALCULATED FROM 640 GROUP SAND STRUCTURE BY         '/
     1' E(I)=SQRT(EL(I)*EL(I+1))   EL(I): SAND-II ENERGIES,          '/
     1' FOR SAND-STRUCTURE: PROGRAM ETAB FROM SAND-II IS USED.       '/
     1' THE NAME OF THE OUTPUT FILE IS ASKED BY THE PROGRAM FROM     '/
     1' TERMINAL                                                     ')
      WRITE(6,3002)
 3002 FORMAT(' '/
     *' THE OUTPUT FILE CONTAINS:                        '/
     *'                                                  '/
     *' LINE 1: HEADLINE (20A4)                          '/
     *' LINE 2: MODE,MEV                                 '/
     *' MODE=0  SPECTRAL POINT VALUES                    '/
     *'     =1  SPECTRAL GROUP FLUENCE VALUES (PER DE)   '/
     *'     =2  GROUP FLUENCE VALUES                     '/
     *'     =3  GROUP FLUENCE PER LETHARGY               '/
     *' MEV=0   ENERGIES ARE GIVEN IN EV                 '/
     *' MEV=1   ENERGIES ARE GIVEN IN MEV (DEFAULT)      '/
     *' MEV=2   ENERGIES ARE GIVEN IN KEV                '/
     *' FORMAT(1H,2(I4,1H,))                            '/)
C
      WRITE(6,3713)
 3713 FORMAT(/
     *' LINE 3:                                                      '/
     *' I1,I2,I,EL(641),IUN                  FORMAT(1H,3(I4,E12.5)  '/
     *' I1: FIRST INDEX (1)                                          '/
     *' I2: LAST  INDEX (640)                                        '/
     *' I:  NUMBER OF VALUES (640)                                   '/
     *' IUN:   IUN=0  (NO UNCERTAINTIES PRINTED INTO THE FLUENCE FILE'/
     *'           =1  UNCERTAINTIES PRINTED (NOT FOR THIS PROGRAM)   '/
     *' LINE 4 TO LAST LINE E(I),FLUX(I)     FORMAT(1H,1P2(E12.4)   '/
     1'                                                              ')
      WRITE(6,3003)
 3003 FORMAT(' '/
     1' +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'/
     1' THE SPECTRUM IS NORMALIZED TO 1000      '/
     1' *************************************************************'/
     1' '//)
C
      WRITE(*,5555)
C
 5555 FORMAT(' NAME OF NEW FLUENCE OUTPUT FILE ?  '/)
      READ(5,7777,END=9911,ERR=9911) LISTE
 9911 WRITE(6,9912) LISTE
 7777 FORMAT(A20)
 9912 FORMAT(' NAME OF OUTPUT FILE: ',A20/)
C
      OPEN(15,FILE=LISTE,STATUS='NEW',FORM='FORMATTED')
C
      RETURN
      END
C*********************************************
      SUBROUTINE OUTFLU(IOUT,EL,Y,SIG,MPL,KG,HEAD,MODE,MEV,IUN)
      CHARACTER*4 HEAD(20)
      DIMENSION EL(MPL),Y(KG),SIG(KG)
C      LINE NO. 1:
C
C                  COMMENT LINE (LESS THAN 80 CHARACTERS)
C
C
C      LINE NO. 2: MODE, MEV (TWO INTEGER VARIABLES SEPARATED BY KOMMA)
C                  MODE = 0: SPECTRAL POINT VALUES OF THE FLUENCE FOLLOW
C                       = 1: MEAN SPECTRAL FLUENCE VALUES FOLLOW, I.E.
C                            F(I)/(EL(I+1)-EL(I))
C                       = 2: GROUP FLUENCE VALUES F(I) FOLLOW.
C                       = 3: MEAN GROUP FLUENCE VALUES PER UNIT LETHARGY
C                            FOLLOW, I.E. F(I)/LOG (EL(I+1)/EL(I))
C                  MEV  = 0: THE FOLLOWING ENERGIES ARE GIVEN IN EV
C                       = 1: THE FOLLOWING ENERGIES ARE GIVEN IN MEV
C                            (DEFAULT)
C                       = 2: THE FOLLOWING ENERGIES ARE GIVEN IN KEV.
C
C      LINE NO. 3: IL, IH, KG, EL(KG+1), IUN
C
C                  WITH:
C                  IL: FIRST INDEX E.G. 1
C                  IH: LAST INDEX E.G. KG
C                  KG: NUMBER OF GROUPS (OR POINTS FOR MODE=0)
C                  EL(KG+1) LAST RIGHT ENERGY BOUNDARY OR DUMMY VARIABLE
C                          FOR MODE=0
C
C                  IUN=1:  UNCERTAINTIES OF THE FLUX VALUES FOLLOW.
C                          THIS NUMBER IS NORMALLY NOT USED IN THE
C                          PROGRAMS
C
C      LINE NO. 4 TO LINE NO. KG+3:
C                  EL(I), FLUX(I), SIG(I)
C
C                  WITH
C                  EL(I):   LEFT BOUNDARY IN ENERGY INTERVAL:
C                  FLUX(I):FLUENCE VALUE DEPENDING ON MODE
C                  SIG(I): STANDARD-DEVIATION OF FLUX(I), IF IUN=1
C
C
C OUTPUT:
C FACTOR FOR EV, KEV, MEV:
      FFAKT=1.0
      IF(MEV.EQ.0) FFAKT=1.0E6
      IF(MEV.EQ.2) FFAKT=1.0E3
      WRITE(IOUT,10) HEAD
   10 FORMAT(20A4)
      WRITE(6,20) HEAD,MODE,MEV
   20 FORMAT(' '/' OUTPUT HEADLINE FLUENCE FILE:'/' ',20A4/
     *' MODE=',I4,' MEV=',I4/)
      WRITE(IOUT,21) MODE,MEV
   21 FORMAT(' ',2(I4,1H,))
      I1=1
      I2=KG
      EDUM=EL(MPL)*FFAKT
      WRITE(IOUT,30) I1,I2,KG,EDUM,IUN
   30 FORMAT(' ',3(I4,','),1P,E12.5,', ',I4)
      DO 40 I=1,KG
      Y(I)=Y(I)*(EL(I+1)-EL(I))
      IF(IUN.EQ.1) SIG(I)=SIG(I)*(EL(I+1)-EL(I))
      IF(MODE.EQ.0) THEN
        EHILF=SQRT(EL(I)*EL(I+1))*FFAKT
      ELSE
        EHILF=EL(I)*FFAKT
      END IF
      IF(MODE.LT.2) THEN
        XHILF=(EL(I+1)-EL(I))*FFAKT
        Y(I)=Y(I)/XHILF
        IF(IUN.EQ.1) SIG(I)=SIG(I)/XHILF
      END IF
      IF(MODE.EQ.3) THEN
        Y(I)=Y(I)/ALOG(EL(I+1)/EL(I))
        IF(IUN.EQ.1) SIG(I)=SIG(I)/ALOG(EL(I+1)/EL(I))
      END IF
      IF(IUN.EQ.1) THEN
        WRITE(IOUT,41) EHILF,Y(I),SIG(I)
      ELSE
        WRITE(IOUT,41) EHILF,Y(I)
      END IF
   40 CONTINUE
   41 FORMAT(' ',1P,3(E12.4,','))
      RETURN
      END
C****************** FOLLOWING THE ROUTINE PLBILD ******
C****************** FOR SCREEN GRAFICS, WHICH MAY BE REPLACED
C****************** BY A DUMMY ROUTINE
      SUBROUTINE
     *PLBILD(X,Y,SIG,NP,LAY,MODIN,MODPL,FAKT,IZEIG,TEXT,COM,MEV)
C
      CHARACTER*20 TEXT,COM
      LOGICAL OD
      DIMENSION X(NP),Y(NP),SIG(NP)
C IZEIG=0 KEIN BILD
C IZEIG=1 BILD WIRD GEZEIGT, EINGABE ERWARTET
C IZEIG=2 BILD WIRD GEZEIGT UND BLEIBT STEHEN
C
C LAY=0 KEIN NEUER RAHMEN
C LAY=1 LIN-LIN
C    =2 LOG-LIN
C    =3 LIN-LOG
C    =4 LOG-LOG
C LAY NEGATIV: F(E)*E GEPLOTTET
C
C MODIN=1 HISTOGRAMMWERTE ALS EINGABE
C      =2 PUNKTWERTE ALS EINGABE
C
C MODPL=1 HISTOGRAMM
C      =2 LINIE
C      =3 PUNKTE
C MODIN NEGATIV: UNSICHERHEITEN GEPLOTTET
      INQUIRE(UNIT=29,OPENED=OD)
      IF(.NOT.OD) THEN
      OPEN(29,FILE='PLOTOB',FORM='UNFORMATTED',STATUS='OLD',ERR=30)
   30 OPEN(29,FILE='PLOTOB',FORM='UNFORMATTED',STATUS='NEW')
      END IF
      WRITE(29) NP,LAY,MODIN,MODPL,FAKT,IZEIG,TEXT,COM,MEV
C
      WRITE(29) X,Y,SIG
      RETURN
      END
