C     PROGRAM UMSDAT BY M. MATZKE                              VERSION 11-90
C
C     THIS PROGRAM MAKES A FORMATTED COPY OF
C     INPUT DATA FILE TO FILES IN THE MIEKE FORMAT
C
C     TAPE5  = INPUT FILE (TERMINAL), NAMED 'CON'
C              ASSIGN YOUR INPUT FILE OR THE TERMINAL TO CON
C     TAPE6  = OUTPUT FILE OR LINE PRINTER (LPT1)
C     TAPE7  = ONE OF THE DATA FILES OF THE STACKAGE E.G. PS1.DAN
C     TAPE17 = DATA FILE TO CONNECT THE REACTION CODE NAMES
C              WITH THE MAT AND MT NUMBERS OF THE IRDF FILE
C              (IN THE PACKAGE IT IS NAMED MCROBI.DAT)
C              AS INPUT DATA FILE.
C              CONTENTS OF THE FILES: SEE BELOW
C
C     OUTPUT FILES:
C
C     TAPE8  = ACTIVITY OUTPUT FILE
C     TAPE9  = COVARIANCE OF ACTIVITIES
C
C     TAPE10 = FLUENCE OUTPUT FILE IN SPECIAL FORMAT
C     TAPE11 = COVARIANCE OF FLUENCE
C
C     TAPE12 = WEIGHTING SPECTRUM OUTPUT FILE IN SPECIAL FORMAT
C
C     THE NAMES OF ALL THE FILES WITH THE EXCEPTION OF TAPE5=CON
C     ARE READ FROM TAPE5
C
C EXAMPLE:
C  CONVERT PS1.DAN TO THE FILES AND THE FORMATS OF THE MIEKE PACKAGE
C
C TYPE EITHER UMSDAT < UMSDATIN.PS1 FOR READING FROM INPUT FILE
C UMSDATIN.PS1 OR TYPE UMSDAT FOR USING TERMINAL INPUT
C
C
C  EXAMPLE OF THE INPUT DATA IN FILE UMSDATIN.PS1:
C  UMSDATPR.PS1               COMMENT: PRINTER OUTPUT FILE
C  PS1.DAN                             INPUT DATA FILE
C  ACT2.PS1                            OUTPUT ACTIVITY FILE
C  COVACT.PS1                          OUTPUT COVARIANCE OF ACTIVITIES
C  MCROBI.DAT                          FILE WITH REACTION CODES AND MAT, MT
C  F1.PS1                              OUTPUT FLUENCE FILE
C  CF.PS1                              OUTPUT COVARIANCE OF FLUENCE
C  W1.PS1                              OUTPUT WEIGHTING SPECTRUM
C  2                                   MODE (GROUP FLUENCE VALUES IN PS1.DAN)
C  640                                 NUMBER OF GROUPS FOR WEIGHTING SPECTRUM
C  1                                   MODE (GROUP FLUENCE VALUES PER ENERGY)
C
C
C INPUT DATA IN THE INPUT FILE (FORMAT-FREE):
C  LINE NO:
C
C    1          NAME OF PRINTER FILE E.G. LPT1
C    2          INPUT DATA FILE, ONE OF THE FILES IN THE PACKAGE
C    3          NAME OF OUTPUT ACTIVITY FILE
C    4          NAME OF OUTPUT COVARIANCE OF ACTIVITIES
C    5          NAME OF THE FILE CONTAINING REACTION CODES, MAT AND MT
C    6          NAME OF OUTPUT FLUENCE FILE
C    7          NAME OF OUTPUT COVARIANCE OF FLUENCE
C    8          NAME OF OUTPUT WEIGHTING SPECTRUM
C    9          MODE FOR GROUP FLUENCE VALUES IN THE INPUT DATA FILE
C               MODE=1:  GROUP FLUENCE PER UNIT ENERGY
C               MODE=2:  GROUP FLUENCE VALUES
C               MODE=3   GROUP FLUENCE PER UNIT LETHARGY
C   10          NUMBER OF GROUPS FOR WEIGHTING SPECTRUM IN THE INPUT
C               DATA FILE
C   11          MODE FOR THE WEIGHTING SPECTRUM IN THE INPUT DATA FILE
C               SEE LINE NUMBER 9
C
C------------------------------------------------------------------------
C  YOU SHOULD FIRST HAVE A LOOK AT THE INPUT DATA FILE 2 TO FIND OUT
C  WHICH VALUES FOR MODE ARE NEEDED.
C
C*************************************************************************
C
C EXAMPLE OF THE DATA FILE 17 FOR CONNECTION OF REACTION CODES WITH
C MAT AND MT NUMBERS:
C THERE ARE 37 MATERIALS AND 2 COVERS, WHICH ARE IMPORTANT FOR THE
C PRESENT PROBLEMS.
C EXAMPLE FILE MCROBI.DAT:
C------------------------------------------------------------------------
C  **** CREATING MS640 FROM IRDF-90.MTZ WITH PROGRAM MCROBI
C  51
C  LI6AT                           325  105            LI6(N,T)
C  LI6A                           6424  207            LI6(N,A)
C  B10A                            525  107            B10(N,A)
C  F192                            925   16            F19(N,2N)
C  MG24P                          1225  103            MG24(N,P)
C  AL27P                          1325  103            AL27(N,P)MG27
C  AL27A                          1325  107            AL27(N,A)NA24
C  P31P                           1525  103            P31(N,P)
C  S32P                           1625  103            S32(N,P)
C  SC45G                          2125  102            SC45(N,G)SC46
C  TI46P                          2225  103            TI46(N,P)SC46
C  TI47P                          2228  103            TI47(N,P)SC47
C  TI48NP                         2231   28            TI48(N,NP)
C  TI48P                          2231  103            TI48(N,P)SC48
C  CR522                          2431   16            CR52(N,2N)
C  MN552                          2525   16            MN55(N,2N)MN54
C  FE54P                          2625  103            FE54(N,P)MN54
C  FE56P                          2631  103            FE56(N,P)MN56
C  FE58G                          2637  102            FE58(N,G)FE59
C  CO592                          2724   16            CO59(N,2N)CO58
C  CO59G                          2725  102            CO59(N,G)CO60
C  CO59A                          2725  107            CO59(N,A)MN56
C  NI582                          2825   16            NI58(N,2N)NI57
C  NI58P                          2825  103            NI58(N,P)CO58
C  NI60P                          2831  103            NI60(N,P)CO60
C  CU632                          2925   16            CU63(N,2N)
C  CU63G                          2925  102            CU63(N,G)CU64
C  CU63A                          2925  107            CU63(N,A)CO60
C  CU652                          2931   16            CU65(N,2N)
C  ZN64P                          3025  103            ZN64P
C  Y892                           3925   16            Y89(N,2N)
C  ZR902                          4025   16            ZR90(N,2N)
C  NB932                          4125   16            NB93(N,2N)
C  NB93N                          4125   51            NB93(N,N')
C  RH103N                         4525   51            RH103(N,N')
C  IN115N                         4931   51            IN115(N,N)IN115
C  IN115G                         6437  102            IN115(N,G)IN116
C  I1272                          6438   16            I127(N,2N)
C  AU1962                         7924   16            AU197(N,2N)
C  AU197G                         7925  102            AU197(N,G)AU198
C  TH232F                         9040   18            TH232F
C  TH232G                         9040  102            TH232G
C  U235F                          9228   18            U235(N,F)F.P.
C  U238F                          9237   18            U238(N,F)F.P.
C  U238G                          9237  102            U238(N,G)
C  NP237F                         6337   18            NP237(N,F)F.P.
C  PU239F                         9437   18            PU239(N,F)F.P.
C  ST-D-AST                       8000  800            STEEL-DISPL. ASTM
C  ST-D-EUR                       8001  801            STEEL-DISPL. EUR
C  CR-D-EUR                       8002  800            DAMAGE XSECT EUR
C  NI-D-EUR                       8003  800            DAMAGE XSECT EUR
C      3
C  B   525   1
C  CD 4800   1
C  GD 6400   1
C
C---------------------------------------------------------------------
C  NOTE: VANISHING GROUP FLUENCE VALUES FOR A WEIGHTING SPECTRUM
C        ARE NONSENSE. THE PROGRAM ADDS IN THAT CASE SMALL VALUES
C
C*************************************************************************
C
      CHARACTER*4 HEAD(20),IREAC(40,2),STRICH,INAM(60,2)
      DIMENSION ENER(641),FI(641),ACT1(40),SIG1(40)
     *,SD(641),IFELD(5000),ENER2(641),SD2(641),IFELD2(5000)
     *,MAT(60),MT(60)
      CHARACTER*20 LIST6,LIST7,LIST8,LIST9,LIST10,LIST11,LIST12
     *,LISTE,LIST18
      CHARACTER*20 TEXT,COM
C
      DATA LISTE/'                    '/
      WRITE(*,70)
   70 FORMAT(' PROGRAM UMSDAT TO CONVERT THE DATA FILE TO USER FORMAT'/
     *' M. MATZKE                                     VERSION 11-90'//
     *' TAPE5  = INPUT FILE (TERMINAL) '/
     *' TAPE6  = OUTPUT FILE (LINE PRINTER) (LPT1)'/
     *' TAPE7  = ONE OF THE DATA FILES, E.G. PS1.DAN'/
     *'                                 '/
     *' TAPE8  = ACTIVITY OUTPUT FILE     '/
     *' TAPE9  = COVARIANCE OF ACTIVITIES '/
     *'                                   '/
     *' TAPE10 = FLUENCE OUTPUT FILE IN SPECIAL FORMAT'/
     *' TAPE11 = OUTPUT FILE COVARIANCE OF FLUENCE   '/
     *'                                               '/
     *' TAPE12 = WEIGHTING SPECTRUM OUTPUT FILE IN SPECIAL FORMAT'/
     *' TAPE17 = DATA FILE CONNECTING THE REACTION CODES WITH '/
     *'          THE MAT AND MT-NUMBERS'/
     *' '/)
 1400 FORMAT(A20)
      OPEN(5,FILE='CON')
C
      WRITE(*,71)
 71   FORMAT(' GIVE NAME OF PRINTER FILE (LPT1)'/)
      LIST6=LISTE
      READ(5,1400) LIST6
      OPEN(6,FILE=LIST6,ERR=333)
      GOTO 334
  333 OPEN(6,FILE=LIST6,STATUS='NEW')
  334 WRITE(6,171)
  171 FORMAT(' ***********PROGRAM UMSDAT***********************'//
     *' TO CONVERT THE INPUT DATA FILE TO USER FORMAT'/
     *' M. MATZKE                                 VERSION 11-90'//)
C
      WRITE(*,72)
   72 FORMAT(' GIVE NAME OF INPUT DATA FILE'/)
      LIST7=LISTE
      READ(5,1400) LIST7
      OPEN(7,FILE=LIST7,STATUS='OLD')
C
      WRITE(*,73)
   73 FORMAT(' GIVE NAME OF OUTPUT ACTIVITY FILE'/)
      LIST8=LISTE
      READ(5,1400) LIST8
      WRITE(*,74)
   74 FORMAT(' GIVE NAME OF OUTPUT COVARIANCE FILE OF ACTIVITIES'/)
      LIST9=LISTE
      READ(5,1400) LIST9
C
      WRITE(*,731)
  731 FORMAT(' GIVE NAME OF FILE 17 FOR THE CONNECTION OF'/
     1' THE REACTION CODES WITH MAT AND MT NUMBERS'/)
      LIST18=LISTE
      READ(5,1400) LIST18
      OPEN(17,FILE=LIST18,STATUS='OLD',FORM='FORMATTED')
C
      WRITE(6,75) LIST7,LIST18,LIST8,LIST9
   75 FORMAT(' '/
     *' INPUT DATA FILE           :  ',A20/
     *' DATA FILE CONNECTING THE'/
     *' REACTION CODE WITH MAT, MT:  ',A20/
     *' OUTPUT ACTIVITY FILE      :  ',A20/
     *' COVARIANCE OF ACTIVITIES  :  ',A20/)
      OPEN(8,FILE=LIST8,STATUS='NEW')
      OPEN(9,FILE=LIST9,STATUS='NEW')
C
C
      WRITE(*,1402)
 1402 FORMAT(' GIVE NAME OF OUTPUT FLUENCE FILE'/)
      LIST10=LISTE
      READ(5,1400) LIST10
      OPEN(10,FILE=LIST10,FORM='FORMATTED',STATUS='NEW')
      WRITE(*,1403)
 1403 FORMAT(' GIVE NAME OF OUTPUT FLUENCE COVARIANCE FILE'/)
      LIST11=LISTE
      READ(5,1400) LIST11
      OPEN(11,FILE=LIST11,FORM='FORMATTED',STATUS='NEW')
C
      WRITE(*,1404)
 1404 FORMAT(' GIVE NAME OF OUTPUT FLUENCE WEIGHTING FILE'/)
      LIST12=LISTE
      READ(5,1400) LIST12
      OPEN(12,FILE=LIST12,FORM='FORMATTED',STATUS='NEW')
C
      WRITE(6,1610) LIST10,LIST11,LIST12
 1610 FORMAT(' '/
     *' OUTPUT FLUENCE FILE     : ',A20/
     *' FLUENCE COVARIANCE FILE : ',A20/
     *' WEIGHTING SPECTRUM      : ',A20/)
C READ MAT NUMBERS
      READ(17,1) HEAD
      READ(17,*) MIRDF
      DO 728 I=1,MIRDF
  728 READ(17,'(2A4,21X,I6,1X,I4)') INAM(I,1),INAM(I,2),MAT(I),MT(I)
      CLOSE(17)
C
C***********************************************************************
C BEGIN READING TAPE 7:
      READ (7,1) HEAD
C
      WRITE(6,1401) LIST7,HEAD
 1401 FORMAT(' '/
     *' HEADLINE OF THE INPUT DATA FILE 7 (',A20,' ) :'/
     *' ',20A4/)
C
C NUMBER OF ACTIVITIES:
      READ(7,*) KA
      WRITE(6,9335) KA
 9335 FORMAT(' NUMBER OF ACTIVITIES: ',I5/)
      WRITE(8,1) HEAD
      WRITE(8,'(I5)') KA
C
      READ(7,1406) (ACT1(I),IREAC(I,1),IREAC(I,2),I=1,KA)
 1406 FORMAT(3(E10.3,1X,2A4,2X))
C
      READ(7,1) HEAD
      READ(7,1) HEAD
      WRITE(9,1) HEAD
      READ(7,*) KA
      WRITE(9,'(I5)') KA
      READ(7,1407) (SIG1(I),I=1,KA)
 1407 FORMAT(10(8E10.3/))
      WRITE(9,'(1P,8E10.3)') (SIG1(I),I=1,KA)
C
      WRITE(6,172)
  172 FORMAT(' '/' CONTENTS OF THE ACTIVITY FILE :'/)
      DO 1409 I=1,KA
C LOCATE MAT,MT
      KIRDF=MIRDF+1
      DO 8633 K=1,MIRDF
      IF(INAM(K,1).EQ.IREAC(I,1).AND.INAM(K,2).EQ.IREAC(I,2)) KIRDF=K
 8633 CONTINUE
      WRITE(6,1413) IREAC(I,1),IREAC(I,2),ACT1(I),SIG1(I),MAT(KIRDF),
     1MT(KIRDF)
      WRITE(8,1410) IREAC(I,1),IREAC(I,2),ACT1(I),SIG1(I),MAT(KIRDF),
     1MT(KIRDF)
 1409 CONTINUE
 1410 FORMAT(2A4,1P,E10.3,0P,F10.3,1X,I6,1X,I4)
 1413 FORMAT(' ',2A4,1P,E10.3,0P,F10.3,1X,I6,1X,I4)
C
      CLOSE(8)
      NRU=(KA*(KA+1))/2
      READ(7,1411) (IFELD(I),I=1,NRU)
      WRITE(9,1411) (IFELD(I),I=1,NRU)
 1411 FORMAT(16I5)
      CLOSE(9)
C
C  READ DUMMY LINE
      READ(7,1) HEAD
C
      READ(7,1) HEAD
      WRITE(*,11) HEAD
   11 FORMAT(' '/' HEADLINE FOR THE INPUT FLUENCE:'/
     *' ',20A4/)
      WRITE(10,1) HEAD
      READ(7,1) HEAD
      WRITE(*,7233) HEAD
 7233 FORMAT(' DATA ON THE INPUT FLUENCE FILE:'/' ',20A4/
     *' MODE=1 :GROUP FLUENCE RATE PER UNIT ENERGY'/
     *' MODE=2 :GROUP FLUENCE RATE VALUES'/
     *' MODE=3      "   "      "   PER UNIT LETHARGY'/
     *' GIVE MODE')
      READ(5,*) MODE
C
    1 FORMAT (20A4)
    2 FORMAT (5X,20A4)
      READ (7,*) NG
      WRITE(6,3396) NG
 3396 FORMAT(' '/' NUMBER OF GROUPS IN FLUENCE PART: ',I5/)
      IF(NG.GT.100) THEN
      WRITE(*,235) NG
  235 FORMAT(' MORE THEN 100 GROUPS, STOP! NG=',I5/)
      END IF
    3 FORMAT (I5)
    4 FORMAT (I10)
      NG1=NG+1
      READ (7,6) (ENER(I),I=1,NG1)
    6 FORMAT(8E10.3)
    5 FORMAT(1P,8E10.3)
      READ (7,6) (FI(I),I=1,NG)
      DO 7038 I=1,NG
      IF(MODE.EQ.2) GOTO 7038
      IF(MODE.EQ.1) FI(I)=FI(I)*(ENER(I+1)-ENER(I))
      IF(MODE.EQ.3) FI(I)=FI(I)*ALOG(ENER(I+1)/ENER(I))
 7038 CONTINUE
C
C READ DUMMY FROM DATA BEFORE COVARIANCE
      READ(7,1) HEAD
      STRICH=HEAD(2)
C
C BEGIN READING COVARIANCE DATA
      READ (7,1) HEAD
      READ (7,*) NG2
      WRITE(6,2048) NG2
 2048 FORMAT(' NUMBER OF GROUPS COVARIANCE FILE OF FLUENCE: ',I4/)
      MPL2=NG2+1
      READ (7,5) (ENER2(I),I=1,MPL2)
      READ (7,5) (SD2(I),I=1,NG2)
      NRU=(MPL2*NG2)/2
      READ(7,2099) (IFELD2(I),I=1,NRU)
C
      IF(NG2.NE.NG) THEN
      WRITE(6,2049)
 2049 FORMAT(' DIFFERENT GROUP STRUCTURE, COVARIANCE MATRIX CONVERTED')
C
      DO 2050 I=1,NG
C LOCATE INDEX 1:
      I3=0
      DO 2051 I1=1,NG2
      IF(I3.NE.0) GOTO 2052
      IF(ENER2(I1).LE.ENER(I).AND.ENER2(I1+1).GT.ENER(I)) I3=I1
 2051 CONTINUE
 2052 CONTINUE
      SD(I)=SD2(I3)
      DO 2053 J=1,NG
      J3=0
      DO 3051 J1=1,NG2
      IF(J3.NE.0) GOTO 3052
      IF(ENER2(J1).LE.ENER(J).AND.ENER2(J1+1).GT.ENER(J)) J3=J1
 3051 CONTINUE
 3052 CONTINUE
C I3,J3 : INDEX IN OLD COVARIANCE FILE
C I,J   : INDEX IN NEW COVARIANCE FILE
      IJU3=I3+(J3*J3-J3)/2
      IF(I3.GT.J3) IJU3=J3+(I3*I3-I3)/2
      IHILF=IFELD2(IJU3)
      IJU=I+(J*J-J)/2
      IF(I.GT.J) IJU=J+(I*I-I)/2
      IFELD(IJU)=IHILF
 2053 CONTINUE
 2050 CONTINUE
      NRU=(NG*NG1)/2
      ELSE
      DO 2060 I=1,NG
 2060 SD(I)=SD2(I)
      DO 2061 I=1,NRU
 2061 IFELD(I)=IFELD2(I)
      END IF
C
C
C OUTPUT COVARIANCE:
      WRITE(11,1) HEAD
      WRITE(11,'(I5)') NG
      WRITE(11,5) (ENER(I),I=1,NG1)
      WRITE(11,5) (SD(I),I=1,NG)
      WRITE(11,2099) (IFELD(I),I=1,NRU)
 2099 FORMAT(16I5)
C
C  OUTPUT SPECTRUM:
C
      MODE=1
      MEV=1
      IUN=1
      WRITE(10,*) MODE,MEV
      IL=1
      IH=NG
      WRITE(10,*) IL,IH,NG,ENER(NG1),IUN
C
      SUM=0.0
      DO 8735 I=1,NG
      SUM=SUM+FI(I)
      FI(I)=FI(I)/(ENER(I+1)-ENER(I))
      SD(I)=SD(I)*FI(I)/100.0
 8735 WRITE(10,8736) ENER(I),FI(I),SD(I)
 8736 FORMAT(' ',1P,3(E12.5,',  '))
C
C
      WRITE(6,2000) SUM
 2000 FORMAT(' '/' NORM OF OUTPUT FLUENCE: ',1PE12.4)
      MEV=1
      TEXT(1:20)=LIST10
      TEXT(15:20)='OUTPUT'
      COM(1:20)='FLUX PER DLNE       '
      CALL PLBILD(ENER,FI,SD,NG1,-2,-1,1,1.0,1,TEXT,COM,
     1MEV)
      COM(1:14)='FLUX PER DE   '
      CALL PLBILD(ENER,FI,SD,NG1,2,-1,1,1.0,1,TEXT,COM,MEV)
      COM(1:13)='FLUX PER DLNE'
      CALL PLBILD(ENER,FI,SD,NG1,-2,-1,1,1.0,0,TEXT,COM,MEV)

      CLOSE(10)
 1430 CONTINUE
      READ(7,1) HEAD
      WRITE(11,1) HEAD
      IF(HEAD(2).NE.STRICH) GOTO 1430
      CLOSE(11)
C
C
      READ(7,1) HEAD
      WRITE(12,1) HEAD
      WRITE(*,12) HEAD
   12 FORMAT(' '/' HEADLINES FOR WEIGHTING SPECTRUM:'/' ',20A4/)
      READ(7,1) HEAD
      WRITE(*,13) HEAD
      READ(7,1) HEAD
      WRITE(*,13) HEAD
   13 FORMAT(' ',20A4)
      WRITE(*,1450)
 1450 FORMAT(' GIVE NUMBER OF ENERGY GROUPS FOR WEIGHTING SPECTRUM'/)
C
      READ(5,*) NG
      NG1=NG+1
      READ (7,55) (ENER(I),I=1,NG1)
      READ (7,1) HEAD
C
      WRITE(*,7233) HEAD
C
      READ(5,*) MODE
      READ (7,55) (FI(I),I=1,NG)
   55 FORMAT(7E11.3)
C
      WRITE(12,7733)
 7733 FORMAT(' 1,  1,')
      IUN=0
      WRITE(12,7734) NG,NG,ENER(NG1),IUN
 7734 FORMAT(' 1,',I5,' , ',I5,', ',E12.5,',',I4)
      XHILF=1.0E-20
      INULL=0
      DO 7735 I=1,NG
      IF(MODE.EQ.2) GOTO 7739
      IF(MODE.EQ.1) FI(I)=FI(I)*(ENER(I+1)-ENER(I))
      IF(MODE.EQ.3) FI(I)=FI(I)*ALOG(ENER(I+1)/ENER(I))
 7739 FI(I)=FI(I)/(ENER(I+1)-ENER(I))
      IF(FI(I).GT.0.0) THEN
        XHILF=FI(I)
      ELSE
        FI(I)=XHILF*1.0E-4
        INULL=1
      END IF
      SD(I)=FI(I)
 7735 WRITE(12,7736) ENER(I),FI(I),SD(I)
      IF(INULL.NE.0) THEN
        WRITE(6,2217)
 2217 FORMAT(' '/' SPECTRAL FLUENCE VALUES OF THE WEIGHTING'/
     *' SPECTRUM WERE FOUND TO VANISH. THESE VALUES WERE CORRECTED'/
     *' TO A SMALL CONTRIBUTION'/)
      END IF
 7736 FORMAT(' ',1P,3(E12.5,',  '))
      SUM1=0.0
      DO 8835 I=1,NG
      SUM1=SUM1+FI(I)*(ENER(I+1)-ENER(I))
 8835 CONTINUE
      DO 8836 I=1,NG
 8836 FI(I)=FI(I)*SUM/SUM1
C
      TEXT(1:20)=LIST12
      CALL PLBILD(ENER,FI,SD,641,0,1,1,1.0,1,TEXT,COM,1)
      WRITE(6,666) SUM1
  666 FORMAT(' '//' NORM WEIGHTING  SPECTRUM: ',1PE12.4)
C
      STOP
      END
C****************** FOLLOWING THE ROUTINE PLBILD ******
C****************** FOR SCREEN GRAFICS, WHICH MAY BE REPLACED
C****************** BY A DUMMY ROUTINE
      SUBROUTINE
     *PLBILD(X,Y,SIG,NP,LAY,MODIN,MODPL,FAKT,IZEIG,TEXT,COM,MEV)
C
      CHARACTER*20 TEXT,COM
      LOGICAL OD
      DIMENSION X(NP),Y(NP),SIG(NP)
C IZEIG=0 KEIN BILD
C IZEIG=1 BILD WIRD GEZEIGT, EINGABE ERWARTET
C IZEIG=2 BILD WIRD GEZEIGT UND BLEIBT STEHEN
C
C LAY=0 KEIN NEUER RAHMEN
C LAY=1 LIN-LIN
C    =2 LOG-LIN
C    =3 LIN-LOG
C    =4 LOG-LOG
C LAY NEGATIV: F(E)*E GEPLOTTET
C
C MODIN=1 HISTOGRAMMWERTE ALS EINGABE
C      =2 PUNKTWERTE ALS EINGABE
C
C MODPL=1 HISTOGRAMM
C      =2 LINIE
C      =3 PUNKTE
C MODIN NEGATIV: UNSICHERHEITEN GEPLOTTET
      INQUIRE(UNIT=29,OPENED=OD)
      IF(.NOT.OD) THEN
      OPEN(29,FILE='PLOTOB',FORM='UNFORMATTED',STATUS='OLD',ERR=30)
   30 OPEN(29,FILE='PLOTOB',FORM='UNFORMATTED',STATUS='NEW')
      END IF
      WRITE(29) NP,LAY,MODIN,MODPL,FAKT,IZEIG,TEXT,COM,MEV
C
      WRITE(29) X,Y,SIG
      RETURN
      END
