C MODIFICATION BY M.MATZKE, PTB
C PROGRAM UNC33M (MODIFIED) UNC33-PROGRAM (H. NOLTHENIUS)
C        VERSION 2-91
C        THE PROGRAM UNDERSTANDS NOW THE ENDF-B/VI FORMAT
C        FORMATS OF INPUT FILES: LOOK AT THE MIEKE PACKAGE
C
C
C
C
C ---------------------------------------------------------------
C OLD COMMENT OF THE ORIGINAL PROGRAM: (NOT VALID)
C ----  UNC3301, VERSION IV (=FORTRAN-IV) CONVERTS COVARIANCE
C ----  DATA OF THE FILE33 INTO A COVARIANCE MATRIX FOR A SPECIFIED
C ----  GROUP STRUCTURE. (IN FILE33 OF ENDF/B-V, THE 'COVARIANCES
C ----  OF NEUTRON CROSS-SECTIOS', APPEARING IN FILE3 OF ENDF/B-V,
C ----  ARE GIVEN.)
C ---------------------------------------------------------------
C
C     FILE NO.  1 = SCRATCH
C     FILE NO.  2 = SCRATCH
C     FILE NO.  3 = IRDF LIBRARY IN THE ENDF/B FORMAT
C     FILE NO.  5 = USER'S INPUT NAMED 'CON'
C                   CHANGE YOUR INPUT FILE-NAME TO CON
C     FILE NO.  6 = PRINTED OUTPUT
C     FILE NO.  7 = COVARIANCE MATRICES (FORMATTED)
C     FILE NO.  8 = CROSS-SECTIONS (FORMATTED) OUTPUT SAND-II FORMAT
C     FILE NO.  9 = THE SAME AS FILE 8 BUT BINARY OUTPUT
C                   NOTE: YOU MAY USE FILE 9 FOR UNFOLDING CODES
C                   IF NO SHIELDING HAS TO BE PERFORMED AND IF NO
C                   ADDITIONAL (I.E. PSEUDO-) CROSS SECTIONS ARE NEEDED.
C                   IN THE  OTHER CASES USE FILE 15 TOGETHER WITH
C                   MFITIB TO CALCULATE GROUP CROSS SECTIONS
C     FILE NO. 15 = X-SECTIO LIBRARY IN SAND-II STRUCTURE (UNFORMATTED)
c                   OUTPUT FROM MCROBI
C                   OPTIONAL:
C     FILE NO. 16 = COVARIANCE MATRICES GENERATED FROM THE FILE 32
C                   OF THE IRDF LIBRARY
C                   THE NAME OF THE FILE SHOULD BE :XSC1
C                   ********************************************
C                   * DIRECT ACCESS STORAGE DEVICE IS REQUIRED *
C                   ********************************************
C                   USE THE PROGRAM XS32FM
C                   YOU HAVE A SWITCH VARIABLE ON INPUT TO IGNORE XSC1
C     FILE NO. 17 = SCRATCH
C     FILE NO. 18 = SCRATCH
C     FILE NO. 25 = COARSE FLUENCE FILE (GROUP FLUENCE PER UNIT ENERGY)
C     FILE NO. 26 = WEIGHTING SPECTRUM (GROUP FLUENCE PER UNIT ENERGY)
C                   YOU HAVE A SWITCH VARIABLE AT INPUT TO IGNORE
C                   OPENING FILE 26 AND TO USE 1/E WEIGHTING
C     FILE NO. 27 = ACTIVITY FILE CONTAINING THE NAMES OF THE REACTIONS
C                   AND THE MAT AND MT NUMBERS
C                   FOR THE PREPARATION OF A DAMAGE CROSS SECTION FILE
C                   THE ACTIVITY FILE SHOULD BE CHANGED FOR THE DAMAGE
C                   NAMES INSTEAD OF THE ACTIVITY NAMES
C
C
C
C ALL NAMES OF THE FILES WITH THE EXCEPTION OF XSC1 AND SCRATCH
C ARE READ FROM THE INPUT FILE TAPE5
C
C
C EXAMPLE OF AN INPUT FILE TAPE 5:
C
C  unc33mpr.ps1           comment printer file  output
C  act.ps1                        activity file  input
c  f1.ps1                         coarse fluence file input
c  irdf.bin                       binary 640 input cross section file
c  1                              weighting spectrum available
c  w1.ps1                         weighting file
c  irdf-90.mtz                    original irdf file
c  cov.ps1                        output covariance file
c  cross.ps1                      output formatted cross section file
c  crossbi.ps1                    output unformatted cross section file
c  1                              xsc32m90 output file xsc1 needed
C
C EXAMPLE OF AN ACTIVITY FILE (SEE GENERAL DESCRIPTION OF THE MIEKE PACKAGE):
c the mat numbers in the example given here are for irdf-85
C   REAL88 **** PS1 **** ORNL POOLSIDE FAC., POSITION: SIMUL. SURV. CAPS.
C       9,  1,             comment: beam incidence through GD cover
C   U235F    1.382E-03     8.000   9228   18 GD  3.026e-3
C   CO59G    3.818E-04     4.000   2725  102 GD  3.026e-3
C   SC45G    5.864E-05     4.000   2125  102 GD  3.026e-3
C   FE58G    5.219E-06     4.000   2637  102 GD  3.026e-3
C   NP237F   7.096E-05     8.000   6337   18 GD  3.026e-3
C   NI58P    2.264E-06     4.000   2825  103 GD  3.026e-3
C   FE54P    1.541E-06     4.000   2625  103 GD  3.026e-3
C   TI46P    2.190E-07     4.000   2225  103 GD  3.026e-3
C   CU63A    1.076E-08     4.000   2925  107 GD  3.026e-3
C   10
C   ST-D-AST
C   ST-D-EUR
C   CR-D-EUR
C   NI-D-EUR
C   PHI-INT*
C   PHI-0.1*
C   PHI-1.0*
C   PHI-TOT*
C   NI58P
C   CO59G
C   ST-D-AST
C
C
C        BESIDES THE HEAD-LINE AND THE NUMBER OF REACTIONS
C******* ONLY THE NAMES, MAT AND MT NUMBERS ARE NEEDED FROM THE ACTIVITY
C        FILE WITH  FORMAT(2A4,21X,I6,1X,I4)
C
C**************************************************************************
C****************************************************************
      INTEGER PMAT,PMT
      LOGICAL OD
      CHARACTER*20 LIST8,LIST9
      CHARACTER*4 HCCARD(20),INAM(2),NTKN(2),CN1,CN2,bk2(4)
C
      COMMON /CENDF/ E(30),EENDF(641),FFIJN(100,100),LTY,NP,IXSC1
      COMMON /CSAND/ ESAND(641),FLSAND(640),NGSAND,WI(640),WJ(640)
      COMMON /CUSER/ CMUSER(100,100),EUSER(101),NGUSER,REUSER(100),
     1   CRUSER(100),LLOW1(101),LHIG1(101)
      COMMON /FI2ST/ OD,EEE1,EEE2
C
      DATA NTKN/'NOTK','NOWN'/,bk2/'    ','    ','    ','    '/
C
C DEFINE FILE NAMES:
      CALL FILEOP(IWET,LIST8,LIST9)
      OD=.FALSE.
C
C READ COMMENT CARD FROM THE ACTIVITY FILE:
      READ (27,80) HCCARD
   80 FORMAT (20A4)
      WRITE (6,81) HCCARD
   81 FORMAT (' COMMENT CARD TO IDENTIFY FILE 27: '/' ',20A4/)
C
C     ****************      **********
C READ COMMENT CARD FOR COARSE FLUENCE:
      READ (25,80) HCCARD
      WRITE(6,3541) HCCARD
 3541 FORMAT(' '/' COMMENT CARD OF FILE 25 (COARSE FLUENCE FILE)'/
     *' ',20A4/)
C     ****************      **********
C
C
C READ ALL THE COARSE FLUENCE VALUES FROM FILE 25
      READ (25,*) MODE,MEV
      READ(25,*) IL,IH,NGUSER,EDUM
C ---------------------------------------------------------------
C ----  NGUSER IS THE NUMBER OF USER GROUPS
C ---------------------------------------------------------------
      WRITE (6,82) NGUSER
   82 FORMAT ('   NUMBER OF USER GROUPS (NGUSER)',17X,':',I5)
      NGUSR1=NGUSER+1
C
      EUSER(NGUSR1)=EDUM
C YOU NEED FLUENCE RATE PER UNIT ENERGY
      DO 3281 I=1,NGUSER
 3281 READ(25,*) EUSER(I),EDUM
C END READING COARSE FLUENCE
      CLOSE(25)
      WRITE(18,'(I10)') NGUSR1
      WRITE(18,'(1P,8E10.3)') (EUSER(I),I=1,NGUSR1)
C NOCOVERS
      NCOVE=0
      WRITE(18,'(I10)') NCOVE
C ---------------------------------------------------------------
C ----  USER DEFINED ENERGY-VALUES EUSER ARE EXPECTED TO BE IN MEV'S
C ----CONVERT TO EV  --------------------------------------------
      DO 2 I=1,NGUSR1
    2 EUSER(I)=EUSER(I)*1.E+6
C READ SAND ENERGIES FROM THE LIBRARY
      READ (15) NGSND1
      NGSAND=NGSND1-1
      READ (15) (ESAND(I),I=1,NGSND1)
C SKIP OVER THE COVERS
      CALL SKIPEC(15)
C
C READ WEIGHTING SPECTRUM
      WRITE (6,84)
   84 FORMAT (' '/' --- WEIGHTING SPECTRUM ---'/)

      IF(IWET.EQ.0) THEN
       WRITE(6,*) '1/E WEIGHTING SPECTRUM'
       DO 743 I=1,NGSAND
       EENDF(I)=ESAND(I)
  743  FLSAND(I)=ALOG(ESAND(I+1)/ESAND(I))
      EENDF(NGSND1)=ESAND(NGSND1)
      ELSE
C
      READ (26,80,END=998,ERR=998) HCCARD
      WRITE (6,83) HCCARD
   83 FORMAT (' COMMENT CARD TO IDENTIFY THE WEIGHTING SPECTRUM: '/
     1' ',20A4/)
C ---------------------------------------------------------------
C ----
C ----  FLSAND-VALUES ARE EXPECTED TO BE GROUP FLUX VALUES
C       PER UNIT ENERGY
C ---------------------------------------------------------------
C
      READ(26,*) MODE,MEV
      READ(26,*) IL,IH,NGSAND,EDUM
      DO 3282 I=1,NGSAND
      READ(26,*) EENDF(I),FLSAND(I)
      IF(ABS(1.0-EENDF(I)/ESAND(I)).GT.1.0E-4) THEN
        WRITE(6,1993) I, EENDF(I),ESAND(I)
        WRITE(*,1993) I, EENDF(I),ESAND(I)
 1993 FORMAT(' ENERGIES FOR WEIGHTING SPECTRUM DO NOT AGREE WITH'/
     1' LIBRARY VALUES: I=',I4,' E-WEIGHT=',1P,E12.4,' E-LIB=',E12.4/)
        STOP
      END IF
      EENDF(I)=0.0
 3282 CONTINUE
      CLOSE(26)
      END IF
C CONVERT TO GROUP FLUXES
      SUM=0.0
      DO 3283 I=1,NGSAND
      FLSAND(I)=FLSAND(I)*(ESAND(I+1)-ESAND(I))
 3283 SUM=SUM+FLSAND(I)
      DO 3284 I=1,NGSAND
      IF(FLSAND(I).LE.0.0) FLSAND(I)=SUM*1.0E-12
 3284 CONTINUE
C CONVERT TO EV
      DO 1 I=1,NGSND1
    1 ESAND(I)=ESAND(I)*1.E+6
C
C FIND SAND-INDEX  FOR EUSER
      DO 3211 I=1,NGUSER
      DO 222 J=1,NGSAND
      IF (ESAND(J).LE.EUSER(I).AND.ESAND(J+1).GT.EUSER(I)) GOTO 333
 222  CONTINUE
 333  LLOW1(I)=J
      JJ=J
      DO 444 J=JJ,NGSAND
      IF (ESAND(J).LT.EUSER(I+1).AND.ESAND(J+1).GE.EUSER(I+1)) GOTO 555
 444  CONTINUE
 555  LHIG1(I)=J
 3211 CONTINUE
C
C**** NOW LLOW1(I)=ML,LHIG1(I)=MR  ML IS THE INDEX OF ESAND(ML)
C**** WITH ESAND(ML).LE.EUSER(I).LT.ESAND(ML+1)
C****      ESAND(MR).LT.EUSER(I+1).LE.ESAND(MR+1)
C
      WRITE(*,633)
  633 FORMAT(' '/
     1' IXSC1=1 : THE FILE XSC1 FROM THE XSC32F RUN IS USED DURING'
     1,' THIS RUN'/
     1' IXSC1=0 : THE FILE XSC1 IS NOT NEEDED'/
     1' GIVE IXSC1'/)
      READ(5,*) IXSC1
      IF(IXSC1.EQ.1) THEN
C OPEN THE FILE XSC1, WHICH IS THE OUTPUT FILE FROM A XSC32F RUN
      OPEN(16,FILE='XSC1',STATUS='OLD',ACCESS='DIRECT',RECL=2564,FORM=
     *'UNFORMATTED')
      END IF
C
      DO 4 I=1,53
      II=I*12
      II11=II-11
    4 WRITE (6,85) (FLSAND(J),J=II11,II),II
   85 FORMAT (1P,12E10.3,I6)
      WRITE (6,86) (FLSAND(I),I=637,640),NGSAND
C***********  FLSAND(I) ARE GROUP FLUXES *************************
   86 FORMAT (1P,4E10.3,I86)
  111 NMAT=0
      PMAT=0
      PMT=0
C ---------------------------------------------------------------
C  SPECIFY INPUT BY INCREASING MAT- AND MT-NUMBER, TO REDUCE TIME
C ---------------------------------------------------------------
C READ NUMBER OF REACTIONS FROM ACTIVITY FILE
      READ(27,*) NFOHL
      IFLOUT=0
C WRITE NUMBER TO THE CROSS SECTION FILE
      WRITE(18,'(I10)') NFOHL
      IFOHL=0
  900 IFOHL=IFOHL+1
      IF(IFOHL.GT.NFOHL) GOTO 999
C READ MAT AND MT NUMBERS FROM THE ACTIVITY FILE
      READ(27,1123) INAM,MAT,MT
      WRITE(*,2144) INAM,MAT,MT
      WRITE(6,2144) INAM,MAT,MT
C
 2144 FORMAT(' '/
     *' ************************************************'/
     *' REACTION: ',2A4,'  MAT=',I4,'  MT=',I4/
     *' ************************************************'/)
 1123 FORMAT(2A4,21X,I6,1X,I4)
C WRITE NAME AND BLANKS TO THE CROSS SECTION FILE
      WRITE(18,3001) INAM
      CLAM=0.0
      WRITE(18,3002) CLAM,MAT,MT
 3002 FORMAT(1P,E10.3,8X,2X,2I10)
 3001 FORMAT(2A4)
C
      IF (MAT.EQ.0) GO TO 999
      E(1)=ESAND(1)
      EEE1=E(1)
      E(2)=ESAND(641)
      EEE2=E(2)
      LTY=0
      DO 8 I=1,100
      DO 8 J=1,100
    8 CMUSER(I,J)=0.
      IF (PMAT.EQ.MAT) GO TO 11
      NMAT=NMAT+1
      GO TO 12
   11 CONTINUE
   12 WRITE(6,1693) MAT,MT
 1693 FORMAT(' ','SELREC CALLED WITH MAT,MT:',2I5)
      CALL SELREC(1,PMAT,MAT,PMT,MT)
      CALL SECTIO(1,INAM,MATS,MTS,ilow,ihigh)
      PMAT=MAT
      PMT=MT
      IF (.NOT.OD) GO TO 15
      CALL SECTIO(2,NTKN,MATS,MTS,ilow,ihigh)
      PMAT=MATS
      PMT=MTS
      LTY=1
      REWIND 2
      OD=.FALSE.
   15 REWIND 17
      IFLOUT=IFLOUT+1
      CALL PLTCM(ILOW,IHIGH,'XSECTION','  BARNS ',' ENERGY ',
     1'     EV   ')
      WRITE (6,87) INAM,MAT,MT
   87 FORMAT (//'  CROSS-SECTION NAME',4X,':',2A4,10X,
     1' MAT-NUMBER',4X,':',I5,'    MT-NUMBER',4X,':',I5/
     1' ',30('*'),'  END OF MT   ',30('*')/
     1' ',74('*')///)
      READ (17) ILOW,IHIGH,(CRUSER(I),I=ILOW,IHIGH)
      DO 248  I=1,NGUSER
      IF(I.LT.ILOW.OR.I.GT.IHIGH) CRUSER(I)=0.0
  248 CONTINUE
      WRITE (18,3200) (CRUSER(I),I=1,NGUSER)
C FILL COVARIANCE FILE
      WRITE (7,37) INAM,MAT,MT,NGUSER,ILOW,IHIGH
   37 FORMAT (2A4,2X,5I5)
 3200 FORMAT(1P,8E10.3)
C
      DO 40 I=ilow,ihigh
      WRITE (7,32) (CMUSER(I,J),J=ilow,ihigh)
   40 CONTINUE
   32 FORMAT (1P,8E10.3)
C
      REWIND 1
      REWIND 17
      CALL SKIPEC(15)
      GO TO 900
  998 WRITE (6,89)
   89 FORMAT ('ERROR READING')
      STOP 7
  999 WRITE (6,88) NMAT,IFLOUT
   88 FORMAT (' END OF JOB UNC33M'/I5,' MATERIALS HAVE BEEN TREATED'/
     1I5,' REACTIONS HAVE BEEN TREATED'/)
      IF(IFLOUT.NE.NFOHL) THEN
        WRITE(6,8773) NFOHL
 8773   FORMAT(' ATTENTION: THE TREATED NUMBER OF REACTIONS '/
     1  ' AND THE NUMBER OF REACTIONS IN THE OUTPUT LIBRARY'/
     1  ' IS SMALLER THAN THE NUMBER N=',I4,' IN THE ACTIVITY FILE'/)
      END IF
      CLOSE(1)
      CLOSE(2)
      CLOSE(3)
      CLOSE(4)
      CLOSE(15)
      CLOSE(16)
      OPEN(8,FILE=LIST8,STATUS='NEW',FORM='FORMATTED')
      OPEN(9,FILE=LIST9,STATUS='NEW',FORM='UNFORMATTED')
      REWIND 18
      READ(18,*) NGUSR1
      WRITE(8,'(I10)') NGUSR1
      WRITE(9) NGUSR1
      READ(18,'(8E10.3)') (EUSER(I),I=1,NGUSR1)
      WRITE(8,'(1P,8E10.3)') (EUSER(I),I=1,NGUSR1)
      WRITE(9) (EUSER(I),I=1,NGUSR1)
C NOCOVERS
      READ(18,*) NCOVE
      WRITE(8,'(I10)') NCOVE
      WRITE(8,'(I10)') IFLOUT
      WRITE(9) NCOVE
      WRITE(9) IFLOUT
      READ(18,*) NFOHL
C
      CN1='    '
      CN2='    '
      DO 968 I=1,IFLOUT
      READ(18,3001) INAM
      READ(18,3002) CLAM,MAT,MT
      READ(18,3200) (CRUSER(K),K=1,NGUSER)
      WRITE(8,6001) INAM,bk2
 6001 FORMAT(2A4,2X,4A4)
      WRITE(8,3002) CLAM,MAT,MT
      WRITE(8,3200) (CRUSER(K),K=1,NGUSER)
      WRITE(9) INAM,bk2
      WRITE(9) CLAM,CN1,CN2,MAT,MT
      WRITE(9) (CRUSER(K),K=1,NGUSER)
  968 CONTINUE
 9999 STOP
      END
      SUBROUTINE SKIPEC(ITAPE)
C ---------------------------------------------------------------
C ----  SKIP ENERGY AND COVER CROSS-SECTIO DATA ON SAND-II TYPE
C ----  CROSS-SECTIO TAPE ITAPE
C ---------------------------------------------------------------
      REWIND ITAPE
      READ (ITAPE) NGSND1
      READ (ITAPE)
      READ (ITAPE) NCOV
      IF(NCOV.EQ.0) GOTO 2
      DO 1 J=1,NCOV
      READ (ITAPE)
    1 READ (ITAPE)
    2 READ (ITAPE) NFOIL
      RETURN
      END
      SUBROUTINE SELREC(ITAPE,PMAT,MAT,PMT,MT)
C ---------------------------------------------------------------
C ----  SELECT THE ENDF/B-V RECORDS FOR MATERIAL-NUMBER MAT AND
C ----  REACTION-TYPE MT, AND COPY THESE DATA TO SCRATCH TAPE ITAPE.
C ---------------------------------------------------------------
      CHARACTER*4 CDUM4(16)
      CHARACTER*2 CDUM2
      COMMON /FI2ST/ OD,EEE1,EEE2
      LOGICAL OD,OD1
      INTEGER PMAT,PMT
      OD1=.FALSE.
      IF(PMAT.GT.MAT) REWIND 3
      IF (PMAT.EQ.MAT.AND.PMT.GT.MT) REWIND 3
   10 READ (3,80) CDUM4,CDUM2,IMAT,IFIL,ISEC
   80 FORMAT (16A4,A2,I4,I2,I3)
      IF (IMAT.EQ.MAT.AND.IFIL.EQ.33.AND.ISEC.EQ.MT) GO TO 2480
      IF (IMAT.EQ.-1.AND.IFIL.EQ.0.AND.ISEC.EQ.0) GO TO 30
      GO TO 10
 2480 WRITE(6,2482) IMAT,IFIL,ISEC
      WRITE(*,2482) IMAT,IFIL,ISEC
 2482 FORMAT(' ','FOUND MAT,MF,MT: ',3I5)
   20 WRITE (ITAPE,80) CDUM4,CDUM2,IMAT,IFIL,ISEC
      READ (3,81) CDUM4,CDUM2,JSEC
   81 FORMAT (16A4,A2,6X,I3)
      IF (JSEC.NE.0) GO TO 20
      WRITE (ITAPE,83)
   83 FORMAT (80X)
      REWIND ITAPE
      RETURN
   30 IF (ITAPE.EQ.2) OD=.FALSE.
      WRITE (ITAPE,83)
      REWIND ITAPE
      IF (ITAPE.NE.1) GO TO 40
      IF(OD1) THEN
      WRITE (6,82)
      WRITE (*,82)
   82 FORMAT ('   NO SUCH DATA ON THE FILE NO. 3')
      STOP 1
      ELSE
      OD1=.TRUE.
      REWIND 3
      GOTO 10
      END IF
   40 WRITE (6,84) MAT,MT
   84 FORMAT (////'   --- WARNING ---'//' STANDARD MATERIAL: MAT=',
     1  I4,', MT=',I3,' NOT ON IRDF TAPE.'//
     2  ' CONTRIBUTION IGNORED')
        RETURN
      END
      SUBROUTINE SECTIO(ITAPE,INAM,MATS,MTS,ilow,ihigh)
C ---------------------------------------------------------------
C ----  START READING THE ENDF/B-SECTIO CHARACTERIZED BY: MAT, MT
C ----  FROM TAPE ITAPE.
C ---------------------------------------------------------------
      CHARACTER*4 INAM(2)
      INTEGER Z,A,ZOLD,AOLD
      LOGICAL OD
      COMMON /CENDF/ E(30),EENDF(641),FFIJN(100,100),LTY,NP,IXSC1
      COMMON /CSAND/ ESAND(641),FLSAND(640),NGSAND,WI(640),WJ(640)
      COMMON /CUSER/ CMUSER(100,100),EUSER(101),NGUSER,REUSER(100),
     1   CRUSER(100),LLOW1(101),LHIG1(101)
      COMMON /FI2ST/ OD,EEE1,EEE2
C
      DATA ZOLD,AOLD,NLOLD,MATOLD,MTOLD/-1,-1,-1,-1,-1/
      IF(.NOT.OD) GOTO 7823
      E(1)=EEE1
      E(2)=EEE2
 7823 CONTINUE
C NL IS THE NUMBER OF SUB SECTIONS
   20 READ (ITAPE,80) ZA,NL,MAT,MT
      IF (ZA.EQ.0.) GO TO 99
   80 FORMAT (1E11.4,44X,I11,I4,2X,I3)
      ZA=ZA/1000.
      X=AMOD(ZA,1.)
      Z=NINT(ZA-X)
      ZOLD=Z
      A=NINT(X*1000.)
      AOLD=A
      NLOLD=NL
      MATOLD=MAT
      MTOLD=MT
      WRITE (6,81)
   81 FORMAT (/1X,50('-'),' IRDF DATA',7('-'))
      WRITE (6,82) Z
   82 FORMAT (2H Z,50X,':',I5)
      WRITE (6,83) A
   83 FORMAT (2H A,50X,':',I5)
      WRITE (6,84) NL
   84 FORMAT (1X,71('-')/' NUMBER OF SUB-SECTIOS',29X,':',I5/
     *1X,71('-'))
      DO 1 I=1,NL
      WRITE (6,85) I
   85 FORMAT (/1X,39('-'),' SUB-SECTIO NO.:',I3,12('-'))
      READ (ITAPE,86) MAT1,MT1,NC,NI
      IF(I.EQ.1) GOTO 1258
      WRITE(6,1256) MAT,MAT1,MT,MT1,nc,ni,ITAPE
 1256 FORMAT(' ','*************************************'/
     1' ','MAT=',I5,' MAT1=',I5,' MT=',I5,' MT1=',I5,' NC=',i3,' NI='
     1,i3/
     1' ','NEXT SUBSECTIONS ARE SKIPPED DUE TO CROSS'/
     2' ','CORRELATIONS, READING FILE',I5,' STOPPED'/
     2' ','NOTE: THIS PROGRAM CANNOT EVALUATE CROSS CORRELATIONS'/)
      GOTO 99
 1258 CONTINUE
C***************************************************************
   86 FORMAT (22X,4I11)
      IF (MAT1.EQ.0) MAT1=MAT
      WRITE(6,87) MAT,MT,MAT1,MT1
   87 FORMAT ('   MAT,MT,MAT1,MT1',36X,':',I5,I4,I5,I4)
      WRITE (6,88) NC
   88 FORMAT (' NUMBER OF NC-TYPE SUB-SUBSECTIOS',18X,':',I5)
      WRITE (6,89) NI
   89 FORMAT (' NUMBER OF NI-TYPE SUB-SUBSECTIOS',18X,':',I5)
      WRITE (6,90)
   90 FORMAT (1X,71('-'))
      IF (NC.LT.1) GO TO 13
      DO 2 J=1,NC
    2 CALL SUBNC(ITAPE,J,MATS,MTS)
   13 IF (NI.LT.1) GO TO 1
      DO 3 K=1,NI
    3 CALL SUBNI(ITAPE,K,INAM,ILOW,IHIGH)
    1 CONTINUE
      GO TO 20
   99 Z=ZOLD
      A=AOLD
      NL=NLOLD
      MAT=MATOLD
      MT=MTOLD
      WRITE(6,91) MAT,MT
   91 FORMAT (////' --- UNC33M - RESPONSE CALCULATIONS, MAT=',I8,
     1', MT=',I8,' ---'/' --- GROUP-NR',
     2   5X,'ENERGY-BOUNDARIES (EV)',
     3   5X,'RESPONSE  CROSS SECTION'/)
      RSPTOT=0.
      DO 4 I=ILOW,IHIGH
      RSPTOT=RSPTOT+REUSER(I)
    4 WRITE (6,92) I,EUSER(I),EUSER(I+1),REUSER(I),CRUSER(I)
   92 FORMAT (' ',I12,1P,E17.3,' - ',1P,E10.3,1P,E12.4,0P,E12.4)
      WRITE (6,93) EUSER(1),EUSER(NGUSER+1),RSPTOT
   93 FORMAT (' ',12X,1P,E17.3,' - ',1P,E10.3,1P,E12.4)
      CALL STRCRS(MAT,INAM,ILOW,IHIGH)
      RETURN
      END
      SUBROUTINE SUBNC(ITAPE,INC,MATS,MTS)
      COMMON /CENDF/ E(30),EENDF(641),FFIJN(100,100),LTY,NP,IXSC1
      COMMON /CSAND/ ESAND(641),FLSAND(640),NGSAND,WI(640),WJ(640)
      COMMON /FI2ST/ OD,EEE1,EEE2
      LOGICAL OD
      CHARACTER*4 AAA(20),BBB(20)
      REAL XMT(30),WE(2)
      WRITE (6,80) INC
   80 FORMAT (////1X,51('-'),' NC-S.S.:',I3,8('-'))
      READ (ITAPE,81) LTY,MAT,MT
   81 FORMAT (33X,I11,22X,I4,2X,I3)
      WRITE (6,821) LTY
  821 FORMAT(' ','LTY=',I11,' NOTE: LTY=0 CANNOT BE OPERATED',
     1' WITHIN THIS CODE'/)
      IF (LTY.GT.0.AND.LTY.LE.3) GO TO 10
      GO TO 30
   10 READ (ITAPE,82) EEE1,EEE2,MATS,MTS,NEI
C*********************************************** CHANGED
   82 FORMAT (2E11.4,2I11,11X,I11)
      IF (NEI.GT.2)  THEN
        WRITE(6,*) ' NEI.GT.2 CANNOT BE HANDLED'
        GO TO 41
      END IF
C
      READ (ITAPE,83) (E(I),WE(I),I=1,2)
   83 FORMAT (6E11.4)
      WRITE (6,84) EEE1,EEE2,E(1),E(2),MATS
   84 FORMAT (' EEE1, EEE2: ',2E10.4/' E(1), E(2): ',2E10.4,
     *'  STANDARD MAT  (MATS) :',I5)
      WRITE (6,85) MTS
   85 FORMAT ('   STANDARD REACTION TYPE (MTS)',23X,':',I5)
      WRITE (6,86)
   86 FORMAT (' ',72('-'))
      IF (MATS.NE.MAT.AND.LTY.EQ.1) GO TO 20
      GO TO 40
   20 OD=.TRUE.
C ---------------------------------------------------------------
C ----                 A(I)=R(I).S(I)
C ----
C ----  A(I) CROSS-SECTIO OF INTEREST AT ENERGY GROUP I
C ----  R(I) MEASURED RATIO OF A(I) TO S(I) AT ENERGY GROUP I
C ----  S(I) CROSS-SECTIO FROM WHICH A(I) IS EVALUATED (STANDARD)
C ----       AT ENERGY GROUP I
C ----  RATIO MEASUREMENT OVER THE ENERGY-RANGE: E(1)-E(2)
C ---------------------------------------------------------------
C ----  REL.COV(A(I),A(J))=REL.COV(R(I),R(J)) + REL.COV(S(I),S(J))
C ---------------------------------------------------------------
C ----  START SEARCHING FOR STANDARD MATERIAL CHARACTERIZED BY:
C ----                            MATS, MTS
C ---------------------------------------------------------------
C************************ GEAENDERT**************************************
      BACKSPACE 3
      READ(3,1234) AAA
 1234 FORMAT(20A4)
      CALL SELREC(2,MAT,MATS,MT,MTS)
      BACKSPACE 3
      WRITE(6,1235) MATS
 1235 FORMAT(' ','SELREC IS CALLED WITH MATS=',I5)
      REWIND 3
 1236 READ(3,1234) BBB
      DO 1237 I=1,20
      IF(AAA(I).NE.BBB(I)) GOTO 1236
 1237 CONTINUE
      E(1)=ESAND(1)
      E(2)=ESAND(641)
      GO TO 40
   30 IF (LTY.NE.0) GO TO 42
      READ (ITAPE,87) NCI
   87 FORMAT (55X,I11)
      READ (ITAPE,88) (E(I),XMT(I),I=1,NCI)
   88 FORMAT (6E11.4)
   40 WRITE (6,89) INC
   89 FORMAT (' ',50('-'),' EOF S.S.:',I3,8('-'))
      RETURN
   41 WRITE (6,91)
      STOP 2
   91 FORMAT (24H0FILE NO. 3 FORMAT ERROR)
   42 WRITE (6,92)
      STOP 2
   92 FORMAT (23H0LTY.LT.0 .OR. LTY.GT.3)
      END
C***************************************************************
      SUBROUTINE SUBNI(ITAPE,INI,INAM,ILOW,IHIGH)
      CHARACTER*4 INAM(2)
      COMMON /CENDF/ E(30),EENDF(641),FFIJN(100,100),LTY,NP,IXSC1
      COMMON /CSAND/ ESAND(641),FLSAND(640),NGSAND,WI(640),WJ(640)
      DIMENSION X(3000),Y(1000),EENDF1(641)
      WRITE (6,82) INI
   82 FORMAT (/' ',51('-'),' NI-S.S.:',I3,8('-'))
      DO 2 I=1,100
      DO 2 J=1,100
    2 FFIJN(I,J)=0.
C LB=0: ABSOLUTE COMPONENTS NP VALUES (E,F)   LT=0
C LB=1: FRACTIONAL COMPONENTS NP VALUES (E,F),LT=0
C LB=2: FRACTIONAL COMPONENTS NP VALUES (E,F),LT=0
C LB=3: FRACTIONAL COMPONENTS LT.NE.0 (TWO TABLES (E,F))
C LB=4: FRACTIONAL COMPONENTS LT.NE.0 (TWO TABLES (E,F))
C LB=5: FRACTIONAL COMPONENTS E-TABLE AND MATRIX
C LB=8: ABSOLUTE COMPONENETS, NP VALUES (E,F)   LT=0
      READ (ITAPE,80) LT,LB,NPO,NP,MAT,MT
      WRITE(6,688) LT,LB,NPO,NP,MAT,MT
  688 FORMAT(' '/' LT=',I4,' LB=',I4,' NPO=',I5,' NP=',I5,' MAT=',
     *I5,' MT=',I4)
   80 FORMAT (22X,4I11,I4,2X,I3)
      LBB=LB+1
      GO TO(23,23,23,23,23,24,28,28,23),LBB
   28 WRITE (6,27)
   27 FORMAT (////'   LB .EQ. 6 OR 7')
      STOP 3
C LB=0,1,2,3,4,8:
   23 CONTINUE
      READ (ITAPE,81) (EENDF(I),X(I),I=1,NP)
   81 FORMAT (6E11.4)
C
C
      NE=NP-LT
      NEM=NE-1
      GO TO 333
C LB=5 :
   24 LS=LT
      NT=NPO
      NE=NP
      READ (ITAPE,81) (X(I),I=1,NT)
      DO 32 I=1,NE
   32 EENDF(I)=X(I)
C
      NEM=NE-1
      J=NE
      DO 33 I=1,NEM
      IF (LS.NE.1) GO TO 335
      DO 35 IK=I,NEM
      J=J+1
      FFIJN(IK,I)=X(J)
      FFIJN(I,IK)=X(J)
   35 CONTINUE
      GO TO 33
  335 CONTINUE
      DO 34 IK=1,NEM
      J=J+1
      FFIJN(I,IK)=X(J)
   34 CONTINUE
   33 CONTINUE
  333 CONTINUE
C
      IF(LB.EQ.3.OR.LB.EQ.4) THEN
C LB =3 OR LB=4
      DO 40 I=1,LT
      EENDF1(I)=EENDF(I+NP-LT)
      Y(I)=X(I+NP-LT)
   40 CONTINUE
      END IF
      NE1=LT
C DIMENSION CAUSA:
      IF(NE1.EQ.0) NE1=1
      IF(EENDF(1).NE.1.0E-5) WRITE(6,883) EENDF(1)
  883 FORMAT(' ******* EENDF(1).NE.1.0E-5)***** EENDF(1)=',E12.5/)
      WRITE (6,83) (EENDF(I),I=1,NE)
   83 FORMAT (' ENERGY BOUNDARIES (IN EV)'/(1P,12E11.4))
      IF(LB.EQ.5) THEN
      WRITE (6,84)
   84 FORMAT (' COVARIANCE MATRIX',20X,'LOWER TRIANGLE')
      DO 36 I=1,NEM
   36 WRITE (6,85) (FFIJN(I,J),J=1,I)
   85 FORMAT (1P,12E11.4)
      ELSE
  841 FORMAT(' FK-TABLE'/(1P,12E11.4))
      WRITE(6,841) (X(I),I=1,NE)
        IF(LB.EQ.3.OR.LB.EQ.4) THEN
        WRITE(6,83) (EENDF1(I),I=1,NE1)
  843   FORMAT(' FL-TABLE'/(1P,12E11.4))
        WRITE(6,843) (Y(I),I=1,NE1)
        END IF
      END IF
      WRITE (6,86) INI
   86 FORMAT (' ',50('-'),' EOF S.S.:',I3,8('-'))
C*******************************************
      WRITE(*,3321)
 3321 FORMAT(' STRUC IS CALLED')
      CALL STRUC(INAM,INI,LB,MAT,MT,ILOW,IHIGH,X,Y,NE,NE1,EENDF1)
      RETURN
      END
C*****************************************************
      SUBROUTINE STRUC(INAM,INI,LB,MAT,MT,ILOW,IHIGH,X,Y,NE,NE1,EENDF1)
      CHARACTER*4 INAM(2),NAMES(2),NAMEL(4),CDUM1,CDUM2
      COMMON /CENDF/ E(30),EENDF(641),CFIJN(10000),LTY,NGENDF,IXSC1
      COMMON /CSAND/ ESAND(641),FLSAND(640),NGSAND,WI(640),WJ(640)
      COMMON /CUSER/ CMUSER(100,100),EUSER(101),NGUSER,REUSER(100),
     1   CRUSER(100),LLOW1(101),LHIG1(101)
      DIMENSION CRSAND(640),FLUSER(100),CFIJN1(100,100),X(NE),
     1EENDF1(NE1),Y(NE1)
     1,INDF(641),INDF1(641),IINTG(100),IINTG1(100),IINT3(100)
      EQUIVALENCE(CFIJN(1),CFIJN1(1,1))
      LOGICAL IWF,JWF
      WRITE(*,3322) INAM,INI,LB,MAT,MT,NE,NE1
 3322 FORMAT(' ',2A4,' INI=',I5,' LB=',I5,' MAT=',I5,' MT=',I5,
     *' NE=',I5,' NE1=',I5/)
      NGENDF=NE-1
      NGEND1=NE1-1
      IF (INI.GT.1) GO TO 20
      IWF=.FALSE.
      JWF=.FALSE.
      WRITE (6,80) E(1),E(2)
   80 FORMAT ('  E(1):',1P,E10.3,' EV, E(2):',1P,E10.3,' EV')
C
C     IBM VERSION:
   15 READ (15,END=999) NAMES,NAMEL
      GO TO 5
C
  999 WRITE (6,85)
   85 FORMAT(' '/' REACTION NOT ON TAPE15'/' ')
      STOP 4
C******** ATTENTION  CDUM1 CDUM2 MUST BE INSERTED **********************
    5 READ (15) DECAY,CDUM1,CDUM2,MATL,MTL
C
C     ******************************************************
C     * USE THE SAND-TYPE LIBRARY GENERATED BY THE PROGRAM *
C     *         GIVEN IN FILE 40 OF THE REAL84 TAPE        *
C     *         OR USE THE OUTPUT OF MCROBI                *
C     ******************************************************
C
C ---------------------------------------------------------------
C ----  CRSAND-VALUES ARE EXPECTED TO BE IN BARN
C ---------------------------------------------------------------
      READ (15) (CRSAND(I),I=1,NGSAND)
      IF (IWF) GO TO 14
      IF (INAM(1).EQ.NAMES(1).AND.INAM(2).EQ.NAMES(2)) GOTO 32
      IF( MAT.EQ.MATL.AND.MT.EQ.MTL) GO TO 32
      GO TO 14
C ---------------------------------------------------------------
C ----  WI(I) = RESPONSE IN I-TH SAND ENERGY-GROUP
C ---------------------------------------------------------------
   32 WRITE(6,5162) INAM,MATL,MTL
      WRITE(*,5162) INAM,MATL,MTL
 5162 FORMAT(' ','FOUND IN CS640: ',2A4,2X,I5,2X,I5)
      DO 17 I=1,NGSAND
   17 WI(I)=CRSAND(I)*FLSAND(I)
      IWF=.TRUE.
      DO 16 I=1,NGSAND
   16 WJ(I)=WI(I)
      JWF=.TRUE.
   14 IF (.NOT.(IWF.AND.JWF)) GO TO 15
   18 CALL SKIPEC(15)
C
      ILOW=1
      IHIGH=NGUSER
      DO 1 I=1,NGUSER
      CRUSER(I)=0.
      REUSER(I)=0.
      FLUSER(I)=0.
C ---------------------------------------------------------------
C ----  REUSER = RESPONSE IN USER DEFINED GROUP STRUCTURE
C ----  CRUSER = CROSS SECTIO IN USER DEFINED GROUP STRUCTURE
C ---------------------------------------------------------------
      DO 2 J=1,NGSAND
      IF (ESAND(J).GT.EUSER(I+1)) GO TO 3
      IF (ESAND(J+1).LT.EUSER(I)) GO TO 2
      EMIN=AMAX1(ESAND(J),EUSER(I))
      EMAX=AMIN1(ESAND(J+1),EUSER(I+1))
      FRAC=(EMAX-EMIN)/(ESAND(J+1)-ESAND(J))
      FLUSER(I)=FLUSER(I)+FRAC*FLSAND(J)
      REUSER(I)=REUSER(I)+FRAC*WI(J)
    2 CONTINUE
    3 CRUSER(I)=(REUSER(I)/FLUSER(I))
      IF (REUSER(I).NE.0.) GO TO 40
      IF (ILOW.NE.I) GO TO 41
      ILOW=I+1
      GO TO 1
   41 IF (IHIGH.EQ.I) IHIGH=I-1
      GO TO 1
   40 IHIGH=I
    1 CONTINUE
   20 WRITE (17) ILOW,IHIGH,(CRUSER(I),I=ILOW,IHIGH)
C
      MLINKS=1
      DO 1022 I=1,NGSAND
      XHILF=ESAND(I)
      IF(XHILF.LT.EENDF(1).OR.XHILF.GE.EENDF(NE)) THEN
       MLIK=0
      ELSE
  922  CONTINUE
       IF(EENDF(MLINKS).LE.XHILF.AND.XHILF.LT.EENDF(MLINKS+1)) THEN
        MLIK=MLINKS
       ELSE
        MLINKS=MLINKS+1
        IF(MLINKS.LT.NGENDF) GOTO 922
        MLIK=NGENDF
       END IF
      END IF
 1022 INDF(I)=MLIK
C***************************************
C
C  NOW INDF(I)=M WITH EENDF(M).LE.ESAND(I).LT.EENDF(M+1)
C BUT THERE ARE PROBLEMS WITH EENDF(NE).LT.20MEV
C
      MLINKS=1
      DO 111 I=1,NGUSER
      XHILF=EUSER(I)
      IF(XHILF.LT.EENDF(1).OR.XHILF.GE.EENDF(NE)) THEN
       MLIK=0
      ELSE
  222  CONTINUE
       IF(EENDF(MLINKS).LE.XHILF.AND.XHILF.LT.EENDF(MLINKS+1)) THEN
        MLIK=MLINKS
       ELSE
        MLINKS=MLINKS+1
        IF(MLINKS.LT.NGENDF) GOTO 222
        MLIK=NGENDF
       END IF
      END IF
 111  IINTG(I)=MLIK
C
C
C  NOW IINTG(I)=M WITH EENDF(M).LE.EUSER(I).LT.EENDF(M+1)
C BUT THERE ARE PROBLEMS WITH EENDF(NE).LT.20MEV
C
      IF(LB.EQ.3.OR.LB.EQ.4) THEN
      MLINKS=1
      DO 2022 I=1,NGSAND
      XHILF=ESAND(I)
      IF(XHILF.LT.EENDF1(1).OR.XHILF.GE.EENDF1(NE1)) THEN
       MLIK=0
      ELSE
 2922  CONTINUE
       IF(EENDF1(MLINKS).LE.XHILF.AND.XHILF.LT.EENDF1(MLINKS+1)) THEN
        MLIK=MLINKS
       ELSE
        MLINKS=MLINKS+1
        IF(MLINKS.LT.NGEND1) GOTO 2922
        MLIK=NGEND1
       END IF
      END IF
 2022 INDF1(I)=MLIK
C
C  NOW INDF1(I)=M WITH EENDF1(M).LE.ESAND(I).LT.EENDF1(M+1)
C BUT THERE ARE PROBLEMS WITH EENDF1(NE).LT.20MEV
C
      MLINKS=1
      DO 333 I=1,NGUSER
      XHILF=EUSER(I)
      IF(XHILF.LT.EENDF1(1).OR.XHILF.GE.EENDF1(NE1)) THEN
       MLIK=0
      ELSE
  444  CONTINUE
       IF(EENDF1(MLINKS).LE.XHILF.AND.XHILF.LT.EENDF1(MLINKS+1)) THEN
        MLIK=MLINKS
       ELSE
        MLINKS=MLINKS+1
        IF(MLINKS.LT.NGEND1) GOTO 444
        MLIK=NGEND1
       END IF
      END IF
  333 IINTG1(I)=MLIK
C
C  NOW IINTG1(I)=M WITH EENDF1(M).LE.EUSER(I).LT.EENDF1(M+1)
C BUT THERE ARE PROBLEMS WITH EENDF(NE).LT.20MEV
C
      MLINKS=1
      DO 555 I=1,NGENDF
      XHILF=EENDF(I)
      IF(XHILF.LT.EENDF1(1).OR.XHILF.GE.EENDF1(NE1)) THEN
       MLIK=0
      ELSE
  666  CONTINUE
       IF(EENDF1(MLINKS).LE.XHILF.AND.XHILF.LT.EENDF1(MLINKS+1)) THEN
        MLIK=MLINKS
       ELSE
        MLINKS=MLINKS+1
        IF(MLINKS.LT.NGEND1) GOTO 666
        MLIK=NGEND1
       END IF
      END IF
  555 IINT3(I)=MLIK
C
C  NOW INDF1(I)=M WITH EENDF1(M).LE.ESAND(I).LT.EENDF1(M+1)
C BUT THERE ARE PROBLEMS WITH EENDF1(NE).LT.20MEV
C
      END IF
C
C
C INTEGRATE TO FIND THE COVARIANCE IN THE USER GROUPS
      DO 1118 I=ILOW,IHIGH
C ILOW1: SAND-INDEX  LEFT FROM EUSER(I)
      ILOW1=LLOW1(I)
C LHIGH1: SAND-INDEX LEFT FROM EUSER(I+1)
      LHIGH1=LHIG1(I)
C
      DO 1118 J=ILOW,I
C ILOW2: SAND-INDEX LEFT FROM EUSER(J)
      ILOW2 =LLOW1(J)
C LHIGH2: SAND-INDEX LEFT FROM EUSER(J+1)
      LHIGH2=LHIG1(J)
C
C INTEGRATE OVER THE SAND-ENERGIES
      S3=0.0
      S1=0.0
      DO 8881 IL1=ILOW1,LHIGH1
C FIND INTEGRATION LIMITS
      EL1=AMAX1(ESAND(IL1),EUSER(I))
      EH1=AMIN1(ESAND(IL1+1),EUSER(I+1))
C
C IF OUT OF BOUNDARIES SKIP
      IF(EL1.GE.EENDF(NE)) GOTO 1119
      IF(EH1.LE.EENDF(1)) GOTO 8881
      IF((LB.EQ.3.OR.LB.EQ.4).AND.(EL1.GE.EENDF1(NE1))) GOTO 1119
      IF((LB.EQ.3.OR.LB.EQ.4).AND.(EH1.LE.EENDF1(1))) GOTO 8881
C
      IF(EL1.EQ.ESAND(IL1)) THEN
        IS1=INDF(IL1)
        IF(IS1.EQ.0.AND.EL1.LT.EENDF(1)) IS1=INDF(IL1+1)
      ELSE
        IS1=IINTG(I)
        IF(IS1.EQ.0.AND.EL1.LT.EENDF(1)) IS1=IINTG(I+1)
      END IF
C
C FRAC FOR IL1
      FRIL1=(EH1-EL1)/(ESAND(IL1+1)-ESAND(IL1))
      FRIL1=FRIL1*FLSAND(IL1)
C
      DO 8882 IL2=ILOW2,LHIGH2
C FIND INTEGRATION LIMITS
      EL2=AMAX1(ESAND(IL2),EUSER(J))
      EH2=AMIN1(ESAND(IL2+1),EUSER(J+1))
C IF OUT OF BOUNDARIES SKIP
      IF(EL2.GE.EENDF(NE)) GOTO 8881
      IF(EH2.LE.EENDF(1)) GOTO 8882
      IF((LB.EQ.3.OR.LB.EQ.4).AND.(EL2.GE.EENDF1(NE1))) GOTO 8881
      IF((LB.EQ.3.OR.LB.EQ.4).AND.(EH2.LE.EENDF1(1))) GOTO 8882
C
      IF(EL2.EQ.ESAND(IL2)) THEN
        IS2=INDF(IL2)
        IF(IS2.EQ.0.AND.EL2.LT.EENDF(1)) IS2=INDF(IL2+1)
      ELSE
        IS2=IINTG(J)
        IF(IS2.EQ.0.AND.EL2.LT.EENDF(1)) IS2=IINTG(J+1)
      END IF
C
C FRAC FOR IL2
      FRIL2=(EH2-EL2)/(ESAND(IL2+1)-ESAND(IL2))
      FRIL2=FRIL2*FLSAND(IL2)
C
C NOW SAND-INTEGRAL 1 IS TAKEN BETWEEN EL1,EH1
C     SAND-INTEGRAL 2 IS TAKEN BETWEEN EL2,EH2
C FIND INDICES FOR THE RELATIVE CORRELATION MATRIX
C IS1,IS2 ARE THE INDICES FOR EENDF(I) WITH
C EENDF(IS1).LE.EL1.LT.EENDF(IS1+1))
C EENDF(IS2).LE.EL2.LT.EENDF(IS2+1))
C
C CALCULATE THE MEAN VALUE OF THE RELATIVE CORRELATION BETWEEN
C THE INTEGRATION LIMITS OF THE ACTUAL SAND ENERGIES
C
C NOW EENDF(IS1+1).GE.EL1
C NOW EENDF(IS1).LT.EL1.LE.EENDF(IS1+1)
C NOW EENDF(IS2+1).GE.EL2
C NOW EENDF(IS2).LT.EL2.LE.EENDF(IS2+1)
C NOW IS1,IS2 FIRST INDICES IN THE EK-TABLE
      S2=0.0
C
      DO 5533 ISS1=IS1,NGENDF
C IF EENDF(ISS1).GT.UPPER INTEGRATION LIMIT LEAVE LOOP   :
      IF(EENDF(ISS1).GT.EH1) GOTO 6640
C
      EL11=AMAX1(EENDF(ISS1),EL1)
      EH11=AMIN1(EENDF(ISS1+1),EH1)
      IF(EL11.EQ.EH11) GOTO 5533
      FRAC11=(EH11-EL11)/(EH1-EL1)
C
C IF(LB=3.OR.LB=4)  FIND INDEX FOR EL11,EH11 IN EL-TABLE:
      IF(LB.EQ.3.OR.LB.EQ.4) THEN
        IF(EL11.EQ.ESAND(IL1)) THEN
          IS3=INDF1(IL1)
          IF(IS3.EQ.0.AND.EL11.LT.EENDF1(1)) IS3=INDF1(IL1+1)
        ELSE
          IF(EL11.EQ.EUSER(I)) THEN
             IS3=IINTG1(I)
             IF(IS3.EQ.0.AND.EL11.LT.EENDF1(1)) IS3=IINTG1(I+1)
          ELSE
             IS3=IINT3(ISS1)
             IF(IS3.EQ.0.AND.EL11.LT.EENDF1(1)) IS3=IINT3(ISS1+1)
          END IF
        END IF
      END IF
C
      DO 5540 ISS2=IS2,NGENDF
      IF(LB.NE.2.AND.LB.NE.5.AND.ISS1.NE.ISS2) GOTO 5540
C CASES:
C     LB=0  ISS1=ISS2
C     LB=1  ISS1=ISS2
C     LB=2  ALL ISS1,ISS2
C     LB=3  ISS1=ISS2
C     LB=4  ISS1=ISS2
C     LB=5  ALL ISS1, ISS2
C     LB=8  ISS1=ISS2
C IF EENDF(ISS2) GT UPPER INTEGRATION LIMIT LEAVE LOOP   :
      IF(EENDF(ISS2).GT.EH2) GOTO 5533
C
      EL21=AMAX1(EENDF(ISS2),EL2)
      EH21=AMIN1(EENDF(ISS2+1),EH2)
      IF(EL21.EQ.EH21) GOTO 5540
      FRAC21=(EH21-EL21)/(EH2-EL2)
C FOR LB=3  OR LB=4 FIND INDEX FOR EL21 AND EH21
      IF(LB.EQ.3.OR.LB.EQ.4) THEN
        IF(EL21.EQ.ESAND(IL2)) THEN
          IS4=INDF1(IL2)
          IF(IS4.EQ.0.AND.EL21.LT.EENDF1(1)) IS4=INDF1(IL2+1)
        ELSE
          IF(EL21.EQ.EUSER(J)) THEN
             IS4=IINTG1(J)
             IF(IS4.EQ.0.AND.EL21.LT.EENDF1(1)) IS4=IINTG1(J+1)
          ELSE
             IS4=IINT3(ISS2)
             IF(IS4.EQ.0.AND.EL21.LT.EENDF1(1)) IS4=IINT3(ISS2+1)
          END IF
        END IF
      END  IF
C
C INTEGRATION NOW BETWEEN EL11,EH11 AND EL21,EH21
C
C NOTE: THE CROSS SECTION IS CONSTANT IN A SAND INTERVAL
      XHILF=0.0
C LB=0 OR LB=1 :
      IF(LB.EQ.0.OR.LB.EQ.1) THEN
         XHILF=FRAC11*X(ISS1)*FRAC21
      END IF
C LB=2 :
      IF(LB.EQ.2) XHILF=FRAC11*X(ISS1)*X(ISS2)*FRAC21
C LB=5 :
      IF(LB.EQ.5) XHILF=FRAC11*CFIJN1(ISS1,ISS2)*FRAC21
C LB=8 :
      IF(LB.EQ.8) THEN
         IF(EL11.EQ.EL21.AND.EH11.EQ.EH21)
     *   XHILF=FRAC11*X(ISS1)*FRAC21*(EENDF(ISS1+1)-EENDF(ISS1))/
     *   (EH11-EL11)
      END IF
C LB=3 OR LB=4
      IF(LB.EQ.3.OR.LB.EQ.4) THEN
C IF LB.EQ.3.OR LB.EQ.4 USE IS3,IS4
C INTEGRATION NOW BETWEEN EL11,EH11 AND EL21,EH21
C
      S4=0.0
C
C NOW EENDF1(IS3+1).GE.EL11
C NOW EENDF1(IS3).LT.EL11.LE.EENDF1(IS3+1)
C NOW EENDF1(IS4+1).GE.EL21
C NOW EENDF1(IS4).LT.EL21.LE.EENDF1(IS4+1)
C
      DO 7533 ISS3=IS3,NGEND1
      IF(Y(ISS3).EQ.0.) GOTO 7533
C IF EENDF1(ISS3).GT.UPPER INTEGRATION LIMIT LEAVE LOOP   :
      IF(EENDF1(ISS3).GT.EH11) GOTO 7640
C
      EL31=AMAX1(EENDF1(ISS3),EL11)
      EH31=AMIN1(EENDF1(ISS3+1),EH11)
      FRAC31=(EH31-EL31)/(EH11-EL11)
C
      DO 7540 ISS4=IS4,NGEND1
      IF(Y(ISS4).EQ.0.0) GOTO 7540
      IF(LB.EQ.3.AND.ISS3.NE.ISS4) GOTO 7540
C IF EENDF1(ISS4) GT UPPER INTEGRATION LIMIT LEAVE LOOP   :
      IF(EENDF1(ISS4).GT.EH21) GOTO 7533
C
      EL41=AMAX1(EENDF1(ISS4),EL21)
      EH41=AMIN1(EENDF1(ISS4+1),EH21)
      FRAC41=(EH41-EL41)/(EH21-EL21)
      XHILF=0.0
C LB=3 :
      IF(LB.EQ.3) THEN
         IF(ISS1.EQ.ISS2.AND.ISS3.EQ.ISS4) XHILF=FRAC31*X(ISS1)
     *   *Y(ISS3)*FRAC41
      END IF
C LB=4 :
      IF(LB.EQ.4) THEN
        IF(ISS1.EQ.ISS2) XHILF=FRAC31*X(ISS1)*Y(ISS3)*Y(ISS4)*FRAC41
      END IF
      S4=S4+XHILF*FRAC11*FRAC21
 7540 CONTINUE
 7533 CONTINUE
 7640 XHILF=S4
      END IF
C
C
      S2=S2+XHILF
 5540 CONTINUE
 5533 CONTINUE
 6640 CONTINUE
C OUTPUT RELATIVE COVARIANCE
      GRIL1=FRIL1
      GRIL2=FRIL2
      IF(LB.NE.0.AND.LB.NE.8) THEN
        GRIL1=FRIL1*CRSAND(IL1)
        GRIL2=FRIL2*CRSAND(IL2)
      END IF
      S1=S1+GRIL1*S2*GRIL2
      S3=S3+FRIL1*FRIL2
 8882 CONTINUE
 8881 CONTINUE
C
 1119 continue
      IF(REUSER(I).NE.0.0.AND.REUSER(J).NE.0.0)
     *CMUSER(I,J)=CMUSER(I,J)+S1/(REUSER(I)*REUSER(J))
C      CMUSER(I,J)=CMUSER(I,J)+S1/S3
      CMUSER(J,I)=CMUSER(I,J)
 1118 CONTINUE
c     CALL PLTCM(ILOW,IHIGH,'XSECTION','  BARNS ',' ENERGY ',
c    1'     EV   ')
      RETURN
      END
C***************************************************+
      SUBROUTINE STRCRS(MAT,INAM,IL,IH)
      COMMON /CENDF/ E(30),EENDF(641),CFIJN(10000),LTY,NP,IXSC1
      COMMON /CSAND/ ESAND(641),FLSAND(640),NGSAND,WI(640),WJ(640)
      COMMON /CUSER/ CMUSER(100,100),EUSER(101),NGUSER,REUSER(100),
     1   CRUSER(100),LLOW1(101),LHIG1(101)
      CHARACTER*4 INAM(2)
      IF(IXSC1.EQ.0) THEN
       IRTN=1
       RETURN
      END IF
      CALL SECRP(MAT,INAM,NRC,LEN,IRTN)
      IF (IRTN.GT.0) GO TO 999
      LEN1=LEN+1
      CALL RDA1(16,NRC,EENDF,LEN1)
      DO 100 I=IL,IH
      DO 100 J=IL,IH
      DO 103 K=1,LEN
      IF (EENDF(K+1).LE.EUSER(I)) GO TO 103
      IF (EENDF(K).GE.EUSER(I+1)) GO TO 101
      EKLOW=AMAX1(EENDF(K),EUSER(I))
      EKHIGH=AMIN1(EENDF(K+1),EUSER(I+1))
      WKSUM=0.
      DO 102 M=1,NGSAND
      IF (ESAND(M+1).LE.EKLOW) GO TO 102
      IF (ESAND(M).GE.EKHIGH) GO TO 104
      EMIN=AMAX1(EKLOW,ESAND(M))
      EMAX=AMIN1(EKHIGH,ESAND(M+1))
      FRAC=(EMAX-EMIN)/(ESAND(M+1)-ESAND(M))
      WKSUM=WKSUM+FRAC*WI(M)
  102 CONTINUE
  104 CONTINUE
      SUMCOV=0.
      CALL RDA1(16,NRC+K,CFIJN,LEN)
      DO 203 L=1,LEN
      WLSUM=0.
      IF (EENDF(L+1).LE.EUSER(J)) GO TO 203
      IF (EENDF(L).GE.EUSER(J+1)) GO TO 204
      ELLOW=AMAX1(EENDF(L),EUSER(J))
      ELHIGH=AMIN1(EENDF(L+1),EUSER(J+1))
      DO 205 N=1,NGSAND
      IF (ESAND(N+1).LE.ELLOW) GO TO 205
      IF (ESAND(N).GE.ELHIGH) GO TO 206
      EMIN=AMAX1(ELLOW,ESAND(N))
      EMAX=AMIN1(ELHIGH,ESAND(N+1))
      FRAC=(EMAX-EMIN)/(ESAND(N+1)-ESAND(N))
      WLSUM=WLSUM+FRAC*WJ(N)
  205 CONTINUE
  206 CONTINUE
      SUMCOV=SUMCOV+WLSUM*CFIJN(L)
  203 CONTINUE
  204 IF (REUSER(I).NE.0..AND.REUSER(J).NE.0.)
     1   CMUSER(I,J)=CMUSER(I,J)+((SUMCOV*WKSUM)/(REUSER(I)*REUSER(J)))
  103 CONTINUE
  101 CONTINUE
  100 CONTINUE
c     CALL PLTCM(IL,IH,'XSECTION','  BARNS ',' ENERGY ',
c    1'     EV   ')
  999 RETURN
      END
      SUBROUTINE SECRP(MAT,NAME,NRC,LENIJ,IRTN)
C ---------------------------------------------------------------
C ----  (SE)ARCH FOR (C)OVARIANCE DATA DERIVED FROM (R)ESONANCE
C ----  (P)ARAMETERS, ON TAPE16
C ----
C ----  SEARCHING CRITERIA:
C ----                       MAT, NAME
C ----  NRC AND LENIJ ARE RETURNED
C ----
C ----  NRC BEING THE RECORD-NUMBER OF THE FIRST RECORD OF THE
C ----  LENIJ RECORDS OF INTEREST
C ---------------------------------------------------------------
      CHARACTER*4 HCCARD(20),NAME(2),NAMES(2)
      CHARACTER*8 NAMEE
      DIMENSION NMAT(1),MATI(1),IREI(1),NAMLEN(3)
      EQUIVALENCE (NMAT(1),NMAT1),(MATI(1),MATI1),(IREI(1),IREI1)
     *,(NAMES(1),NAMEE)
      IRTN=0
      WRITE (6,80) MAT,NAME
   80 FORMAT (////'   SEARCH FOR COVARIANCE DATA OF:',I13,6X,2A4)
C
      READ(16,REC=1) HCCARD
      WRITE (6,81) HCCARD
   81 FORMAT (18H COVARIANCE-FILE: ,20A4)
      CALL RDA(16,2,NMAT,1)
      NRC=2
      DO 1 I=1,NMAT1
      NRC=NRC+1
      CALL RDA(16,NRC,MATI,1)
      NRC=NRC+1
      CALL RDA(16,NRC,IREI,1)
      DO 2 J=1,IREI1
      NRC=NRC+1
      READ(16,REC=NRC) NAMEE
      NRC=NRC+1
      CALL RDA(16,NRC,NAMLEN,1)
      NRC=NRC+1
      LENIJ=NAMLEN(1)
      IF (MAT.NE.MATI1.OR.
     1   NAME(1).NE.NAMES(1).OR.NAME(2).NE.NAMES(2)) GO TO 2
      WRITE (6,82) NRC
   82 FORMAT (23H0SEARCH COMPLETED, NRC=,I5)
      WRITE (6,83)
   83 FORMAT (' ',50('-'),' SUBR. SECRP ',8('-'))
      RETURN
    2 NRC=NRC+LENIJ
    1 CONTINUE
      IRTN=1
      WRITE (6,84) MAT,NAME
   84 FORMAT (' COVARIANCE DATA DERIVED FROM RESONANCE PARAMETERS'/
     1   '   FOR: MAT=',I5,', NAME= ',2A4/
     2   ' ARE NOT AVAILABLE ON THE FILE NO. 16'/)
      RETURN
      END
      SUBROUTINE PLTCM(IL,IH,FUNC,FUNCU,VAR,VARU)
C ---------------------------------------------------------------
C ----  PLTCM = (P)RINT (L)OWER (T)RIANGLE OF A (C)ORRELATION
C ----          (M)ATRIX
C ---------------------------------------------------------------
      CHARACTER*4 FUNC(2),VAR(2),FUNCU(2),VARU(2)
C
      COMMON /CUSER/ CMUSER(100,100),EUSER(101),NGUSER,REUSER(100),
     1   CRUSER(100),LLOW1(101),LHIG1(101)
      INTEGER COR
      DIMENSION SDEV(100),COR(100)
      ISIZE=IH-IL+1
      WRITE (6,80) FUNC,ISIZE,ISIZE
   80 FORMAT(/' '/
     1' ',2A4,' CORRELATION MATRIX (',I3,' * ',I3,')',10X,
     1   'LOWER TRIANGLE'/)
      WRITE (6,81) VAR,FUNC
   81 FORMAT (' GROUP',1X,'REL.S',1X,2A4,4X,2A4)
      WRITE (6,82) VARU,FUNCU
   82 FORMAT ('  NO','    % ',2X,2A4,4X,2A4)
      DO 1 I=IL,IH
    1 SDEV(I)=SQRT(ABS(CMUSER(I,I)))
      IF(CMUSER(I,I).LT.0.0)  SDEV(I)=-SDEV(I)
      DO 2 I=IL,IH
      DO 3 J=IL,IH
      COR(J)=0.0
      IF (SDEV(I).NE.0.AND.SDEV(J).NE.0.)
     1   COR(J)=NINT((CMUSER(I,J)/(SDEV(I)*SDEV(J)))*100.)
    3 CONTINUE
      SD=SDEV(I)*100.
      WRITE (6,83) I,SD,EUSER(I),CRUSER(I),(COR(J),J=IL,I)
   83 FORMAT (I3,F8.2,1P,E11.3,1P,E11.3,2X,29(I3)/35X,29I3)
    2 CONTINUE
      WRITE (6,84)
   84 FORMAT (' ')
      RETURN
      END
C***********************************************************
      SUBROUTINE RDA(IOUNIT,NREC,NARRAY,LENGTH)
      DIMENSION NARRAY(LENGTH)
C     ENTRY RDA
C     -----------------
C     CDC FTN4 VERSION:
C     ENTRY RDA
C     CALL READMS(IOUNIT,ARRAY,LENGTH,NREC)
C     RETURN
C     -----------------
C     IBM VERSION:
      READ (IOUNIT,REC=NREC) NARRAY
      RETURN
      END
C*********************************************************************
      FUNCTION NINT(X)
      IF (X) 1,2,3
    1 NINT=IFIX(X-.5)
      RETURN
    2 NINT=0
      RETURN
    3 NINT=IFIX(X+.5)
      RETURN
      END
C*********************************************************************
      SUBROUTINE RDA1(IOUNIT,NREC,ARRAY,LENGTH)
      DIMENSION ARRAY(LENGTH)
      READ(IOUNIT,REC=NREC) ARRAY
      RETURN
      END
C ADDED :*******************************
      SUBROUTINE FILEOP(IWET,LIST8,LIST9)
      CHARACTER*20 LIST6,LIST27,LIST25,LIST15,LIST26,LIST3,LIST7
     *,LISTE,LIST8,LIST9
      DATA LISTE /'              '/
C
  501 FORMAT(A20)
      OPEN(5,FILE='CON')
      LIST6=LISTE
C
      WRITE(*,503)
  503 FORMAT(
     1' GIVE NAME OF PRINTER FILE OR PRINTER IDENTIFICATION (LPT1):'/)
      READ(5,501,ERR=504,END=504) LIST6
  504 OPEN(6,FILE=LIST6)
      WRITE(6,600)
  600 FORMAT(' **************** PROGRAM UNC33M  *******************'//
     1' BY M. MATZKE                                VERSION 11-90'/
     1' MODIFIED VERSION OF UNC33 BY H. NOLTHENIUS'//
     1' THE PROGRAM CALCULATES COARSE GROUP COVARIANCE MATRICES'//
     1' ',72('-')/)
      LIST27=LISTE
C
C
      WRITE(*,5555)
C
 5555 FORMAT(' NAME OF INPUT ACTIVITY FILE ?  '/
     *' E.G. ACT.PS1 '/)
      READ(5,501,END=9911,ERR=9911) LIST27
 9911 WRITE(6,9912) LIST27
 9912 FORMAT(' INPUT ACTIVITY FILE: '/
     *' FILE 27: ',A20/)
C
      LIST25=LISTE
      WRITE(*,6655)
 6655 FORMAT(' NAME OF COARSE FLUENCE FILE CONTAINING GROUPS  ?'/)
      READ(5,501,END=8855,ERR=8855) LIST25
 8855 CONTINUE
      WRITE(6,9914) LIST25
 9914 FORMAT(' NAME OF INPUT COARSE FLUENCE FILE FILE 25: ',
     *A20//)
C
      LIST15=LISTE
C
      WRITE(*,6666)
 6666 FORMAT(' NAME OF BINARY INPUT CROSS SECTION FILE (EG. CS640)?'/)
      READ(5,501,END=8888,ERR=8888) LIST15
 8888 CONTINUE
      WRITE(6,9913) LIST15
 9913 FORMAT(' NAME OF BINARY INPUT CROSS SECTION FILE 15: ',
     *A20//)
C
      WRITE(*,2938)
 2938 FORMAT(' IWET=0 : NO WEIGHTING SPECTRUM AVAILABLE'/
     1'      (1/E) WEIGHTING PERFORMED'/
     1' IWET=1 : WEIGHTING SPECTRUM IN A FILE'/
     1' GIVE IWET'/)
      READ(*,*) IWET
C
      IF(IWET.NE.0) THEN
      LIST26=LISTE
      WRITE(*,4422)
 4422 FORMAT(' NAME OF WEIGHTING SPECTRUM FILE ? '/)
      READ(5,501,END=4423,ERR=4423) LIST26
 4423 CONTINUE
      END IF
C
      LIST3=LISTE
      WRITE(*,6613)
 6613 FORMAT(' NAME OF IRDF TAPE (E.G. IRDF90) ?'/)
      READ(5,501,END=8813,ERR=8813) LIST3
 8813 CONTINUE
C
      LIST7=LISTE
      WRITE(*,500)
  500 FORMAT(
     1' GIVE NAME OF OUTPUT COVARIANCE FILE    '/)
      READ(5,501,ERR=502,END=502) LIST7
  502 OPEN(7,FILE=LIST7)
      LIST8=LISTE
      WRITE(*,603)
  603 FORMAT(
     1' GIVE NAME OF OUTPUT CROSS SECTION FILE'/)
      READ(5,501,ERR=604,END=604) LIST8
  604 OPEN(18,STATUS='SCRATCH',FORM='FORMATTED')
      LIST9=LISTE
      WRITE(*,1603)
 1603 FORMAT(
     1' GIVE NAME OF OUTPUT BINARY CROSS SECTION FILE'/)
      READ(5,501,ERR=1604,END=1604) LIST9
C
 1604 WRITE(6,7912) LIST7,LIST8,LIST9
 7912 FORMAT(' '/
     *' OUTPUT COVARIANCE FILE    :  ',A20/
     *' OUTPUT FORMATTED CROSS SECTION FILE :  ',A20/
     *' OUTPUT UNFORMATTED CROSS SECTION FILE :  ',A20/)
C
      OPEN(27,FILE=LIST27,STATUS='OLD',FORM='FORMATTED')
      OPEN(25,FILE=LIST25,STATUS='OLD',FORM='FORMATTED')
      OPEN(15,FILE=LIST15,STATUS='OLD',FORM='UNFORMATTED')
      IF(IWET.EQ.1) OPEN(26,FILE=LIST26,STATUS='OLD',FORM='FORMATTED')
      OPEN(3,FILE=LIST3,STATUS='OLD',FORM='FORMATTED')
      OPEN(1,STATUS='SCRATCH',FORM='FORMATTED')
      OPEN(17,STATUS='SCRATCH',FORM='UNFORMATTED')
      OPEN(2,STATUS='SCRATCH',FORM='FORMATTED')
      RETURN
      END
